void CheckJet(char* fname,char* output="Output.root" )
{ 
  TFile Output(output,"read");
  TCanvas* c1=new TCanvas("c1","c1",600,600);
  c1->SetLogy();
  TH1F* PtH[4];
  PtH[0]=new TH1F("PtNL","PtNL",100,0,10);
  PtH[0]->GetXaxis()->SetTitle("Pt of low mass(<.4GeV) pair (GeV/c)");
  PtH[1]=new TH1F("PtSL","PtSL",100,0,10);
  PtH[2]=new TH1F("PtNS","PtNS",100,0,10);
  PtH[3]=new TH1F("PtSS","PtSS",100,0,10);
  PtH[1]->SetLineColor(2);
  PtH[2]->SetLineColor(3);
  PtH[3]->SetLineColor(4);
  
  TwoTr->Project("PtNL","Pt","E12>10 && abs(M12-.135)<.05&& EDet[0]/(EDet[0]+EDet[1]+EDet[2]+EDet[3])>.5");
  TwoTr->Project("PtSL","Pt","E12>10 && abs(M12-.135)<.05&& EDet[1]/(EDet[0]+EDet[1]+EDet[2]+EDet[3])>.5");
  TwoTr->Project("PtNS","Pt","E12>10 && abs(M12-.135)<.05&& EDet[2]/(EDet[0]+EDet[1]+EDet[2]+EDet[3])>.5");
  TwoTr->Project("PtSS","Pt","E12>10 && abs(M12-.135)<.05&& EDet[3]/(EDet[0]+EDet[1]+EDet[2]+EDet[3])>.5");

  PtH[0]->SetTitle("Blk:NL Red:SL Grn:NS Blue:SS"); 
  PtH[0]->Draw();
  PtH[1]->Draw("same");
  PtH[2]->Draw("same");
  PtH[3]->Draw("same");
  TString Fname="Jchk";
  Fname=Fname+fname+".ps";
  c1->Print(Fname+"(");

  TH1F* h[5];
  TCanvas* c2=new TCanvas("c2","c2",600,600);
  c2->Divide(1,5);
  char cut[200];
  char nam[200];
  Float_t eta[5]={4.0,3.6,3.2,2.8,2.4};
  for(int j=0;j<5;j++)
    {
      sprintf(cut,"abs(M12-.5)<.49 && abs(E12-35)<20 && Z<.7 && abs(Eta-%2.1f)<.2",eta[j]);
      cout<<cut<<"\n";
      sprintf(nam,"TwoPhotM%d",j);
      cout<<nam<<"\n";
      h[j]=new TH1F(nam,cut,200,0,1.);
      TwoTr->Project(nam,"M12",cut);
      h[j]->Print();
      c2->cd(j+1);
      h[j]->GetYaxis()->SetLabelSize(.08);
      h[j]->GetXaxis()->SetLabelSize(.08); 
      //      h[j]->GetXaxis()->SetTitleSize(.1);
      h[j]->GetXaxis()->SetTitle("Pair Mass GeV");      
      h[j]->Draw();
    }; 

  c2->Print(Fname);
  TCanvas* c3=new TCanvas("c3","c3",600,600);

  //  c3->SetLogz();
  TH2F* Loc[3];


  Loc[0]=new TH2F("Loc0","Loc",20,-100,100,20,-100,100);
  TwoTr->Project("Loc0","2*exp(-Eta)*730*sin(Phi):2*exp(-Eta)*730*cos(Phi)","E12>20&&abs(M12-.2)<.18","box");
  Loc[1]=new TH2F("Loc1","Loc",20,-100,100,20,-100,100);
  TwoTr->Project("Loc1","2*exp(-Eta)*730*sin(Phi):2*exp(-Eta)*730*cos(Phi)","E12>40&&abs(M12-.2)<.18","box");
  Loc[2]=new TH2F("Loc2","Loc",20,-100,100,20,-100,100);
  TwoTr->Project("Loc2","2*exp(-Eta)*730*sin(Phi):2*exp(-Eta)*730*cos(Phi)","E12>60&&abs(M12-.2)<.18","box");
  Loc[1]->SetLineColor(2);
  Loc[2]->SetLineColor(4);
  Loc[0]->SetStats(0);
  Loc[0]->SetTitle("Y vs X Pair(Blk:E>20 Red:E>40 Blue:E>60)");
  Loc[0]->GetXaxis()->SetTitle("Star X coord");
  Loc[0]->GetYaxis()->SetTitle("Star Y coord");
  Loc[0]->Draw("box");
  Loc[1]->Draw("boxsame");
  Loc[2]->Draw("boxsame");
  c3->SetLogz(0);
  c3->Print(Fname);
  c3->SetLogz(1);
  c3->Print(Fname);
  c3->Clear();
  c3->Divide(2,2);
  c3->cd(1);
  TwoTr->Draw("M12","Ntracks==2&&abs(Eta-3.65)<.2 && abs(M12-1)<.98&&Z<.7&&abs(E12-50)<10");
  c3->cd(2);
  TwoTr->Draw("M12","Ntracks==2&&abs(Eta-3.65)<.2 && abs(M12-1)<.98&&Z<.7&&abs(E12-70)<10");
  c3->cd(3);
  TwoTr->Draw("M12","Ntracks==2&&abs(Eta-3.65)<.2 && abs(M12-1)<.98&&Z<.7&&abs(E12-90)<10");
  c3->cd(4);
  TwoTr->Draw("M12","Ntracks==2&&abs(Eta-3.65)<.2 && abs(M12-1)<.98&&Z<.7&&abs(E12-110)<10");
  c3->Print(Fname);
  c3->Clear();
  TwoTr->Draw("E12/250","Ntracks==2&&abs(Eta-3.65)<.2 && abs(M12-.55)<.25&&Z<.7&&abs(E12-125)<125");
  c3->SetLogy();
  c3->Print(Fname);
  gStyle->SetPalette(1);
  c3->SetLogy(0);
  c3->SetLogz();
  TwoTr->Draw("Pt:Phi","Ntracks==2&&abs(Eta-3.65)<.2 && abs(M12-.55)<.25&&Z<.7&&abs(Pt-10)<10","zcol");
  c3->Print(Fname);
  c3->SetLogz();
  TwoTr->Draw("Pt:Eta","Ntracks==2&&abs(Eta-3.5)<.7 && abs(M12-.55)<.25&&Z<.7&&abs(Pt-10)<10","zcol");
  c3->Print(Fname+")");
  TString cmd="ps2pdf "+Fname+";rm "+Fname;
  system((const char*)cmd);
  cout<<cmd<<"\n";
}
