TH1D****   CompareRegion(Int_t det, Int_t ro, Int_t co,Int_t color,TCanvas* c1,TFile* pftmp)
{ 
  Bool_t UseEnvironmentFPDCORR=false;
  gROOT->LoadMacro("Legal.C");
  c1->cd();
  c1->SetLogx();
  c1->SetLogy();

  TString str=gSystem->ExpandPathName("$SETFMSENV");
  if(str!="SETFMSENV"){printf("source SetFMSEnv first");exit();};
  gSystem->Load("${FMSSRC}/Fpdchan.so");
    TString FMSTXT =gSystem->ExpandPathName("${FMSTXT}");
  FMSTXT=FMSTXT+"/";
  TString FMSGAIN =gSystem->ExpandPathName("${FMSGAIN}");
  TString FMSCORR =gSystem->ExpandPathName("${FMSCORR}");
  TString QTMAP = gSystem->ExpandPathName("${QTMAP}");
  TString QTMAP2PP = gSystem->ExpandPathName("${QTMAP2PP}");
  TString FMSTXT=gSystem->ExpandPathName("${FMSTXT}");
  cout<<"FMSTXT=" <<FMSTXT <<"\n";
  
  FilesSet*  p_files=new FilesSet(  (char*) FMSTXT,
                                    "fpdped.txt",
                                    (char*) FMSGAIN,
                                    (char*) FMSCORR,
                                    "fill.txt",
                                    "Fake",
                                    "spinpat",
                                    "geom.txt",
                                    (char*) QTMAP,
                                    (char*) QTMAP2PP);
  

  gROOT->LoadMacro("Legal.C");
  gROOT->LoadMacro("./SetFPD.C");
  gStyle->SetPalette(1);
  //***********Set Up FPDCORR
  Int_t RunNum=9010010;
  //get Gain and Gcor from Environmant
  CalibStr* FpdCorr;
  CalibStr* Gcor=new CalibStr(RunNum,(const char*) (FMSTXT+"/"+FMSCORR));
  TH1D* hadc[34][17][4];

  if(!UseEnvironmentFPDCORR)
    {
      cout<<"Using FpdFile.root\n";
      TFile* Fpd=new TFile("FpdFile.root","Read");
      int ver=1;  
      FpdCorr=0;
      CalibStr* FpdCnew=0;
      char strver[100];
      sprintf(strver,"%d",ver);
      while(FpdCnew=(CalibStr*) Fpd->Get(TString("FpdCorrV")+strver))
	{		
	  FpdCorr=FpdCnew;
	  FpdCorr->filename="FpdCorr.txt";
	  FpdCorr->OutName="FpdCorr.txt";
	  ver++;
	  sprintf(strver,"%d",ver);
	  printf("FpdCorr version %d found \n",ver);
	};  
      Fpd->Close();
      FILE* fp=fopen("ChangeFpd.txt","r");
      char line[200];
      if(fp)
	{
	  while(!feof(fp))
	    {
	      if(fgets(line,100,fp))
		{
		  Int_t ew,nst,ro,co;
		  Float_t val;
		  sscanf(line,"SetValue(%d,%d,%d,%d,%f)",&ew,&nst,&ro,&co,&val);
		  if(Legal(ew,nst,ro,co))
		    FpdCorr->SetValue(ew,nst,ro,co,val);
		};
	    };
	  fclose(fp);
	}
      else
	{
	  cout<<"ChangeFpd.txt not found\n";
	};
      cout<<"Now SetFPD\n";
      //      SetFPD(FpdCorr);
      Gcor=FpdCorr;
    }
  else
    {
      return 0;
    };
  
  Gcor->tm(2,3)->Print();

  CalibStr Gain(RunNum,(const char*) (FMSTXT+"/"+FMSGAIN));
  
  TFile* f=0;
  for(int col=co-2;col<co+3;col++)
    {
      printf("col=%d\n",col);
      color++;
      bool first=true;
      c1->Divide(2,2);
      Int_t cntc1=0;
      for(int row=ro-2;row<ro+3;row++)
	{
	  cntc1++;
	  if(cntc1>4)cntc1=1;
	  printf("c1->cd(cntc1)\n");
	  c1->cd(cntc1);
	  c1->GetPad(cntc1)->SetLogy();
	  c1->GetPad(cntc1)->SetLogx();
	  printf("col=%d row=%d \n",col,row);
	  if(Legal(2,det+1,row,col) )
	    {
	      printf("Legal\n");
	      hadc[row][col][det]=0;
	      printf("ok\n");
	      Float_t gcor=Gcor->GetValue(2,det+1,row,col);
	      Float_t gn=gcor*Gain->GetValue(2,det+1,row,col);
	      if(gn<=0)return 0;
	      
	      char file[200];
	      char name[200];
	      char hname[200];
	      sprintf(file,"data2/_Cellr%d_c%d_%d.root",row,col,det);
	      printf("file name=%s \n",file);
	      sprintf(name,"Cellr%d_c%d_%d",row,col,det);
	      sprintf(hname,"hCellr%d_c%d_%d",row,col,det);
	      if(f)delete f;
	      f=new TFile(file);
	      f->ls();
	      printf("%s\n",name);
	      Cell* c=(Cell*) f->Get(name);
	      if(c)
		{
		  c->p_adc->Draw();
		  c1->Update();
		  system("sleep 2");
		  printf("c->GetName=%s\n",c->GetName());
		  char tit[200];
		  printf("hname=%s gcor=%f gn=%f \n",hname,gcor,gn);
		  TH1D* p_hadc;
		  first=true;
		  if(first)
		    {
		      first=false;
		      
		      c->ReScaleHist(c->p_adc,1/gn,1,false);
		      hadc[row][col][det]=new TH1D(*(c->ReScaledHist));
		      p_hadc=hadc[row][col][det];
		      p_hadc->SetName(hname);;
		      sprintf(tit,"%s_gc%f_gn%f",hname,gcor,gn);
		      p_hadc->SetTitle(tit);
		      p_hadc->SetLineColor(color);
		      pftmp->ls();
		      pftmp->cd();
		      p_hadc->Draw();
		      c1->Update();
		      system("sleep 2");
		      p_hadc->Write(hname);
		      
		    }
		  else
		    {
		      
		      c->ReScaleHist(c->p_adc,1/gn,1,false);
		      hadc[row][col][det]=new TH1D(*(c->ReScaledHist));
		      p_hadc=hadc[row][col][det];
		      p_hadc->SetName(hname);
		      sprintf(tit,"%s_gc%f_gn%f",hname,gcor,gn);
		      p_hadc->SetTitle(tit);
		      p_hadc->SetLineColor(color);
		      p_hadc->Draw();
		      c1->Update();
		      system("sleep 2");
		      pftmp->ls();
		      pftmp->cd();
		      p_hadc->Write(hname);
		    };
		};
	    };
	};
      TString same="";
      for(int row=ro-2;row<ro+3;row++)
	{
	  if(Legal(2,det+1,row,col) && false)
	    {
	      printf("draw row=%d col=%d det=%d \n",row,col,det);
	      cout<<"hadc["<<row<<"]["<<col<<"]["<<det<<"]="<<hadc[row][col][det]<<"\n";
	      if(hadc[row][col][det])
		hadc[ro][col][det]->Draw(same);
	      same="same";
	    };
	};
    };
  return hadc ;
};
