{
  gStyle->SetPalette();
  TString str=gSystem->ExpandPathName("$SETFMSENV");
  if(str!="SETFMSENV"){printf("source SetFMSEnv first");exit();};
  gROOT->Reset();
  gStyle->SetPalette(1);
  TString FMSTXT =gSystem->ExpandPathName("${FMSTXT}");
  FMSTXT=FMSTXT+"/";
  TString FMSGAIN =gSystem->ExpandPathName("${FMSGAIN}");
  TString FMSCORR =gSystem->ExpandPathName("${FMSCORR}");
  TString QTMAP = gSystem->ExpandPathName("${QTMAP}");
  TString QTMAP2PP = gSystem->ExpandPathName("${QTMAP2PP}");
  gSystem->Load("${FMSSRC}/Fpdchan.so");
  TString FMSTXT=gSystem->ExpandPathName("${FMSTXT}");
  cout<<"FMSTXT=" <<FMSTXT <<"\n";

  FilesSet*  p_files=new FilesSet(  (char*) FMSTXT,
                                    "fpdped.txt",
                                    (char*) FMSGAIN,
                                    (char*) FMSCORR,
                                    "fill.txt",
                                    "Fake",
                                    "spinpat",
                                    "geom.txt",
                                    (char*) QTMAP,
                                    (char*) QTMAP2PP);

  Bool_t AnalDet[2][6];
  for(Int_t i=0;i<2;i++){for(Int_t j=0;j<6;j++)AnalDet[i][j]=false;};
  AnalDet[0][0]=false;
  AnalDet[0][1]=false;
  AnalDet[1][0]=true;
  AnalDet[1][1]=true;
  AnalDet[1][2]=true;
  AnalDet[1][3]=true;
  
  char* hntName="h111_09";
  dataSet d("./run*.root",p_files,hntName);
  d.GetEntry(1);
  TString names[4]={"NLarge","SLarge","NSmall","SSmall"};
  TH2F* hh[4]={0,0,0,0};
  Float_t  Esum[4];
  Yiqun* rec[4]={0,0,0,0};
  TGraph* gr[4]={0,0,0,0};
  Int_t Nphot[4]={0,0,0,0}
  Float_t Esum4=0.;
  TMatrix* p_adc[4]={0,0,0,0};
  TMatrix* p_Emat[4]={0,0,0,0};
  Float_t m[4]={0.,0.,0.,0.};
  Int_t nentries= d.Input->GetEntries();
  TCanvas* c1=new TCanvas("c1","c1",600,700);
  for(Int_t i=0;i<nentries;i++)
    {

      Int_t nbytes=d.GetEntry(i);
      d.decodeQT();
      printf("entry=%d \n",i);
      c1->Clear();
      c1->Divide(2,2);
      Float_t esum4=0;

      for(Int_t k=0;k<4;k++)
	{
	  printf("start loop\n");
	  printf("A) k=%d\n",k);
	  Esum[k]=0.;
	  m[k]=0;
	  Nphot[k]=0;
	  printf("about to delete gr[k]\n");
	  if(gr[k])
	    {
	      delete gr[k];
	      gr[k]=0;
	      if(gr[k])printf("non-zero gr after delete\n");
	    };
	  printf("delete done\n");
	  if(AnalDet[1][k] )
	    {
	      if(p_adc[k])delete p_adc[k];
	      if(p_Emat[k])delete p_Emat[k];
	      p_adc[k]=p_Emat[k]=0;
	      p_adc[k]=new TMatrix(d.dMatrixQt(k));
	      p_Emat[k]=new TMatrix(d.Em(p_adc[k],2,k+1));
	      if(rec[k])delete rec[k];
	      rec[k]=0;
	      Esum[k]=p_Emat[k]->Sum();
	      esum4+=Esum[k];
	      printf("esum4[%d]=%f \n",k,esum4);
	      if(Esum[k]>8)
		{
		  rec[k]=new Yiqun(p_Emat[k],d.pGeom,d.Rgain,d.Rgaincorr,2,k+1);
		  printf("rec[%d] NPh=%d \n",k,rec[k]->NPh);
		  Nphot[k]=rec[k]->NPh;

		  gr[k]=new TGraph();
		  for(int jj=0;jj<rec[k]->NPh;jj++)
		    {
		      TVector3 v3=rec[k]->ph_coord_lab(jj);
                      TVector3 vL3=d.pGeom->LocalXYZ(2,k+1,v3,true);
		      gr[k]->SetPoint(jj,vL3.X(),vL3.Y());
		    };

		  if(Nphot[k]==2)
		    {
		      TLorentzVector p0=rec[k]->mom(0);
		      TLorentzVector p1=rec[k]->mom(1);
		      m[k]=(p0+p1).Mag();
		      printf("m[%d]=%f\n",k,m[k]);
		    };
		};
	    };
	  printf("finish k=%d \n",k);
	};

      if(esum4>2)
	{
	  printf("esum4=%f\n",esum4);
	  char t2[100];
	  sprintf(t2,"Ev=%d Esum=%f %f %f %f %f ",i,esum4,
		  Esum[0],Esum[1],Esum[2],Esum[3]);
	  printf("%s \n",t2);
	  for(Int_t kk=0;kk<4;kk++)
	    {
	      if(Esum[kk]>0)
		{
		  printf("B) kk=%d \n",kk);
		  c1->cd(kk+1);
		  if(hh[kk])delete hh[kk];
		  hh[kk]=0;
		  Float_t esum=p_Emat[kk]->Sum();
		  char tit[100];
		  sprintf(tit,"Energy=%f NPh=%d && m12=%f",esum ,Nphot[kk],m[kk]);
		  hh[kk]=new TH2F(*p_Emat[kk]);
		  hh[kk]->SetName(names[kk]);
		  hh[kk]->SetTitle(tit);
		  hh[kk]->SetStats(0);
		  hh[kk]->SetMaximum(100.);
		  hh[kk]->SetMinimum(0.001);
		  c1->GetPad(kk+1)->SetLogz();
		  hh[kk]->Draw("zcol");
		  hh[kk]->Draw("textsame");
		  if(gr[kk])gr[kk]->Draw("*");
		}
	    };
	  c1->Update();
	  c1->SetTitle(t2);
	  if(esum4>100){
	  system("sleep 14");
	  };
	};
    };
  
};
