{
  gROOT->Macro("../start.C");
  gSystem->Load("libGeom");
  gROOT->LoadMacro("Legal.C");
  gROOT->LoadMacro("elem.cxx");
  TString Tg=FMSTXT+"/"+FMSGAIN;
  TString Tgc=FMSTXT+"/"+FMSCORR;

  Tgc="./gifs/FmsCorr.txt";

  CalibStr* Gain=new CalibStr(90100100,Tg);
  CalibStr* Gcor=new CalibStr(90100100,Tgc);
  TFile* SheetSet=new TFile("SheetSet.root");
  TObjArray* SheetArray=SheetSet->Get("newSheets");
  for(int j=1;j<5;j++)Gain->tm(2,j)->Print();
  p_files->Print();
  Qt* QT=new Qt(p_files);
  TCanvas* c1=new TCanvas("c1","c1",500,500);
  new TGeoManager("world","the simplest geometry"); 
  TGeoMaterial *mat = new TGeoMaterial("Vacuum",0,0,0);
  TGeoMedium   *med = new TGeoMedium("Vacuum",1,mat);
  TGeoVolume *top = gGeoManager->MakeBox("Top",med,100.,100.,100.);
  gGeoManager->SetTopVolume(top); 
  
  top->SetLineColor(kMagenta); 
  gGeoManager->SetTopVisible();  // the TOP is generally invisible
  int cnt=1;
  Float_t size[4]={5.83,5.83,3.85,3.85};
  Int_t nrows[4]={34,34,24,24};
  Float_t length[4]={60,60,45,45};
  TGeoVolume* cell[16][4][2];
  TObjArray Elems(1300);
  elem* be[1300];
  for(int jsl=0;jsl<16;jsl++)
    {
      for(int jcr=0;jcr<4;jcr++)
	{
	  char str[100];
	  sprintf(str,"Small_c%d_s%d",jcr,jsl);
	  cell[jsl][jcr][0] = gGeoManager->MakeBox(str,med,3.81/2.,3.81/2.,45/2);
	  sprintf(str,"Large_c%d_s%d",jcr,jsl);

	  cell[jsl][jcr][1] = gGeoManager->MakeBox(str,med,5.81/2.,5.81/2.,60/2);
	  int color=1+jsl;
	  if(color==10)color=5;
	  if(color==11)color=2;
	  cell[jsl][jcr][0]->SetLineColor(color);
	  cell[jsl][jcr][0]->SetLineWidth(2);
	  cell[jsl][jcr][1]->SetLineColor(color);
	  cell[jsl][jcr][1]->SetLineWidth(2);

	}
    };
  
  for(int nstb=1;nstb<5;nstb++)
    {
      int sl=0;
      if(nstb<3)sl=1;
      int ins=-1;
      if(nstb==2 || nstb==4)ins=1;
      for(int row=0;row<nrows[nstb-1];row++)
	{
	  for(int col=0;col<nrows[nstb-1]/2;col++)
	    {	
	      if(Legal(2,nstb,row,col))
		{
		  Float_t x0=ins*size[nstb-1]*(col+.5);
		  Float_t y0=-1*size[nstb-1]*(row-nrows[nstb-1]/2+.5);
		  Float_t dx0=size[nstb-1]/2;
		  Float_t dy0=size[nstb-1]/2;
		  
		  be[cnt]=new elem(x0-dx0,x0+dx0,y0-dy0,y0+dy0,nstb,row,col,Gain,Gcor,SheetArray);
		  Elems.Add(be[cnt]);
		  int icrate=QT->dcrate[col+row*nrows[nstb-1]/2][nstb-1]-1;
		  int islot=QT->dslot[col+row*nrows[nstb-1]/2][nstb-1]-1;
		  Float_t xpos,ypos;
		  xpos=ins*size[nstb-1]*(col+.5);
		  if(xpos>0){xpos=xpos+.5;} else {xpos=xpos-.5;};
		  ypos=-1*size[nstb-1]*(row-nrows[nstb-1]/2+.5);
		  if(ypos>0){ypos=ypos+.5;} else {ypos=ypos-.5;};
		  top->AddNode(cell[islot][icrate][sl],cnt++,new TGeoTranslation(xpos,ypos,length[nstb-1]/2));
		  printf("add node %d \n",cnt);
		}
	    }
	};
    };	
  gGeoManager->CloseGeometry();	
  top->Draw();
  TView3D* gv=c1->GetView();
  gv->SetParallel();
  gv->TopView();
  gv->ZoomView(0,1.7);
  TGeoNode* node=gGeoManager->FindNode(30.,2.,1.);
  c1->Print("FMS.gif");
  Float_t Wc[3]={25,1,1};
  Float_t Ndc[3];
  int jcnt=0;
  TIter next(&Elems);
  elem* aeL;
  FILE* pf=fopen("FMStmp2.html","w");
  
  while(aeL=(elem*) next())
    {
      printf("jcnt=%d\n",jcnt++);
      Wc[0]=aeL->xlo;
      Wc[1]=aeL->ylo;
      Wc[2]=1.;
      gv->WCtoNDC(Wc,Ndc);
      aeL->pxlo=c1->XtoPixel(Ndc[0]);
      aeL->pyhi=c1->YtoPixel(Ndc[1]);
      Wc[0]=aeL->xhi;
      Wc[1]=aeL->yhi;
      Wc[2]=1.;
      gv->WCtoNDC(Wc,Ndc);
      aeL->pxhi=c1->XtoPixel(Ndc[0]);
      aeL->pylo=c1->YtoPixel(Ndc[1]);
      aeL->Print();
      aeL->UpdateStr(QT);
      //cout<<aeL->str<<"\n";
      fprintf(pf,(const char*) aeL->str);
    };
  fclose(pf);
  system("rm -f FMS.html;cat FMStmp1.html >>FMS.html;cat FMStmp2.html>>FMS.html;cat FMStmp3.html>>FMS.html");
}
