{

  /*
    This is configured to take Gain from Environment
    It takes FPDCORR from environment if UseEnvironmentFPDCORR is true;
   */
  gROOT->Reset();
  gStyle->SetPalette(1);
  gStyle->SetTitleSize(.08,"t");
  gStyle->SetTitleSize(.05,"x");
  system("touch gifsma;rm -rf gifsma;mkdir gifsma");

  Bool_t UseEnvironmentFPDCORR=false;
  gROOT->LoadMacro("Legal.C");
  TString str=gSystem->ExpandPathName("$SETFMSENV");
  if(str!="SETFMSENV"){printf("source SetFMSEnv first");exit();};
   
  gSystem->Load("${FMSSRC}/Fpdchan.so");
  TString FMSTXT =gSystem->ExpandPathName("${FMSTXT}");
  FMSTXT=FMSTXT+"/";
  TString FMSGAIN =gSystem->ExpandPathName("${FMSGAIN}");
  TString FMSCORR =gSystem->ExpandPathName("${FMSCORR}");
  TString QTMAP = gSystem->ExpandPathName("${QTMAP}");
  TString QTMAP2PP = gSystem->ExpandPathName("${QTMAP2PP}");
  TString FMSTXT=gSystem->ExpandPathName("${FMSTXT}");
  cout<<"FMSTXT=" <<FMSTXT <<"\n";

  FilesSet*  p_files=new FilesSet(  (char*) FMSTXT,
                                    "fpdped.txt",
                                    (char*) FMSGAIN, 
                                    (char*) FMSCORR,
                                    "fill.txt",
                                    "Fake",
                                    "spinpat",
                                    "geom.txt",
                                    (char*) QTMAP,
                                    (char*) QTMAP2PP);
  
  
  gROOT->LoadMacro("Legal.C");
  //  gROOT->LoadMacro("./SetFPD.C");
  gStyle->SetPalette(1);
  //***********Set Up FPDCORR
  Int_t RunNum=9010010;
  //get Gain and Gcor from Environmant
    
  CalibStr* Gcor=new CalibStr(RunNum,(const char*) (FMSTXT+"/"+FMSCORR));
  CalibStr Gain(RunNum,(const char*) (FMSTXT+"/"+FMSGAIN));
  CalibStr* FpdCorr=Gcor;
  if(UseEnvironmentFPDCORR)
    {
      cout<<"Using Environment for FPDCORR ->"<<FMSCORR<<"\n";
    }
  //get FpdCorr from FpdFile.root && ChangeFpd.txt

  TCanvas* c2=new TCanvas("c2","c2",150,150);
  TCanvas* c1=new TCanvas("c1","c1",600,800);
  c1->Divide(4,4);
  c1->Print("Ie.ps(");
  TH1D* h0[16];
  TH1D* h1[16];
  TH1D* h2[16];
  TLine* L1[16];
  for(int j=0;j<16;j++){h0[j]=0;h1[j]=0;L1[j]=0;h2[j]=0;};
  
  if(!UseEnvironmentFPDCORR)
    {
      cout<<"Using FpdFile.root\n";
      TFile* Fpd=new TFile("FpdFile.root","Read");
      int ver=1;  
      FpdCorr=0;
      CalibStr* FpdCnew=0;
      char strver[100];
      sprintf(strver,"%d",ver);
      while(FpdCnew=(CalibStr*) Fpd->Get(TString("FpdCorrV")+strver))
	{		
	  FpdCorr=FpdCnew;
	  FpdCorr->filename="FpdCorr.txt";
	  FpdCorr->OutName="FpdCorr.txt";
	  ver++;
	  sprintf(strver,"%d",ver);
	};  
      Fpd->Close();
      FILE* fp=fopen("ChangeFpd.txt","r");
      char line[200];
      if(fp)
	{
	  while(!feof(fp))
	    {
	      if(fgets(line,100,fp))
		{
		  Int_t ew,nst,ro,co;
		  Float_t val;
		  sscanf(line,"SetValue(%d,%d,%d,%d,%f)",&ew,&nst,&ro,&co,&val);
		  if(Legal(ew,nst,ro,co))
		    {
		      FpdCorr->SetValue(ew,nst,ro,co,val);
		      //		      printf("FpdCorr->SetValue(%d,%d,%d,%d,%f)\n",ew,nst,ro,co,val);
		    };
		  
		};
	    };
	  fclose(fp);
	}
      else
	{
	  cout<<"ChangeFpd.txt not found\n";
	};
      cout<<"Now SetFPD\n";
      //  SetFPD(FpdCorr);
    };
  if(UseEnvironmentFPDCORR)FpdCorr=Gcor;
  
  //***************  Loop ov16er cells 
  cout<<"2,3,9,3="<<FpdCorr->GetValue(2,1,9,3)<<"\n";
  FpdCorr->SetValue(2,1,9,3,0.);
  Int_t rr[4];
  rr[0]=rr[1]=34;
  rr[2]=rr[3]=24;
  TFile* f=0;
  bool first=true;
  int cnt=0;
  Int_t c1cnt=0;

  TH1F* hHm[1300];
  Float_t enom;
  Float_t ewid;
  TFile fou("tmpfou.root","recreate");
  for(int j=0;j<1300;j++)hHm[j]=0;
  for(int det = 0;det<4;det++)
    {
      enom=28;
      ewid=10;
      if(det>1)
	{
	  enom=40;
	  ewid=15;
	};
      printf("det=%d\n",det);
      for(int ro=0;ro<rr[det];ro++)
	{
	  for(int co=0;co<rr[det]/2;co++)
	    {
	      if(Legal(2,det+1,ro,co)          )
		{
		  c1cnt++;
		  cnt++;
		  c1->cd(cnt%16+1);
		  char fname[200];
		  sprintf(fname,"data2/_Cellr%d_c%d_%d.root",ro,co,det);
		  char hname[200];
		  sprintf(hname,"M%d_r%d_c%d_%d",cnt,ro,co,det);
		  char hname2[200];
		  sprintf(hname2,"Mr%dc%dd%d",ro,co,det);

		  f=new TFile(fname,"read");
		  if(f)
		    {
		      TList* keys;
		      keys=f->GetListOfKeys();
		      //     keys->Print();
		      Float_t deltagcorr=0;
		      TIter next(keys);
		      TKey* key;
		      while(key=(TKey*) next())
			{
			  TString name=key->GetName();
			  int cycle=key->GetCycle();
			  char st[10];
			  sprintf(st,";%d",cycle);
			  name=name+st;
			  Int_t indd=name.Index("RecTr");
			  if(indd==0)
			    {
			      TTree* tr=(TTree*) key->ReadObj();
			      if(tr)
				{
				  char cut[200];

				  printf("create hHm[%d]: hname=%s \n",cnt,hname);
				  sprintf(cut,"abs(Epair-%3.0f)<20",enom);
				  hHm[cnt]=new TH1F("tmp","tmp",40,0.,.4);
				  hHm[cnt]->SetName(hname);
				  hHm[cnt]->SetTitle(hname);
				  char cut[200];
				  sprintf(cut,"abs(er-%3.0f)<10&&mr>.02",enom);
				  tr->Project(hname,"mr",cut);
				  hHm[cnt]->Fit("gaus","L","",.06,.2);
				  hHm[cnt]->Draw();
				  fou.cd();
				  hHm[cnt]->Write();
				  c2->cd();
				  TString fgif="gifsma/";
				  fgif=fgif+hname2;
				  Float_t wsmax=hHm[cnt]->GetMaximum();
				  hHm[cnt]->SetMaximum(wsmax*1.35);
				  hHm[cnt]->GetXaxis()->SetTitle("Mass (GeV)");
				  hHm[cnt]->GetXaxis()->SetLabelSize(.06);
				  char scut[200];
				  Float_t mean=hHm[cnt]->GetFunction("gaus")->GetParameter(1);
				  Float_t ssig=hHm[cnt]->GetFunction("gaus")->GetParameter(2);
				  
				  TText mycut(.01,1.15*wsmax,cut);
				  mycut.SetTextSize(.08);
				  sprintf(scut," ave=%4.3f sig=%4.3f",mean,ssig);
				  TText mycut2(.01,1.0*wsmax,scut);
				  mycut2.SetTextSize(.08);
				  hHm[cnt]->Draw();
				  mycut.Draw("same");
				  mycut2.Draw("same");
				  TLine mylin(0.135,0.,0.135,wsmax);
				  mylin.SetLineColor(2);
				  mylin.Draw("same");
				  fgif=fgif+".gif";
				  c2->Print(fgif);
				  
				};
			    };			  
			};
		      printf("out of loop \n");
		      
		      f->Close();
		    };
		};
	    };
	};
    };
  c1->Print("Ma.ps(");
  Int_t cntMax=cnt;
  cnt=0;
  c1->Clear();
  c1->Divide(4,4);
  TList* kys=fou->GetListOfKeys();
  TIter nxt(kys);
  TKey* ky;
  cnt=0;
  while(ky=(TKey*) nxt())
    {
      cnt++;
      if(cnt>16)cnt=1;
      c1->cd(cnt);
      ((TH1F*) ky->ReadObj())->Draw();
      if(cnt>15)
	{
	  c1->Update();
	  c1->Print("Ma.ps");
	};
    }

  c1->Print("Ma.ps)");
  system("ps2pdf Ma.ps;rm Ma.ps;tar -zcf gifsma.tgz gifsma;rm -rf gifsma");
};

