void PlotMore()
{
  gROOT->LoadMacro("Legal.C");
  gROOT->LoadMacro("LogWt.C");
  gROOT->LoadMacro("gcorbyTrig.C");
  TString str=gSystem->ExpandPathName("$SETFMSENV");
  if(str!="SETFMSENV"){printf("source SetFMSEnv first");exit();};
  
  gROOT->Reset();
  gSystem->Load("${FMSSRC}/Fpdchan.so");

  TFile* Fpd=new TFile("FpdFile.root");
  TCanvas* c2=new TCanvas("c2","c2",600,600);
  TCanvas* c1=new TCanvas("c1","c1",600,600);
  Bool_t ReplaceFpd=false;
  if(Fpd)ReplaceFpd=true;
  int ver=1;  
  CalibStr* FpdCorr=0;
  CalibStr* FpdCnew=0;
  TString sver="1";
  Fpd->ls(); 
  TString newname=TString("FpdCorrV")+sver;
  cout<<"1st newname="<<newname<<"\n";

  while(FpdCnew=(CalibStr*) Fpd->Get(newname))
    {		
      FpdCorr=FpdCnew;
      FpdCorr->filename="FpdCorr.txt";
      FpdCorr->OutName="FpdCorr.txt";
      ver++;
      char cver[30];
      sprintf(cver,"%d",ver);
      sver=cver;
      printf("det=0 row=1 col=9 %f \n",FpdCorr->GetValue(2,1,2,9));
      newname=TString("FpdCorrV")+sver;
      cout<<"newname="<<newname<<"\n";

    };
  if(!FpdCorr)exit();

  TFile tmp("tmp.root","update");
  TObjArray* to=tmp.Get("newSheets");
  Sheet* sho=0;
  TIter nxt(to);
  while(sho=(Sheet*) nxt())sho->BackupHistory();


  Cell* c[34][17][4];
  Cell* c16[16];
  Int_t rr[4];
  rr[0]=rr[1]=34;
  rr[2]=rr[3]=24;
  TFile* f[16];
  TH1D* hh[16];
  TH2F* mm[16];
  TLine* line[16];
  TLine* lineADC[16];
  TLine* lineLW[16];
  TText* HVset[16];
  TText* HVset2[16];
  TText* HVset3[16];
  TH1D* gg;
  for(int j=0;j<16;j++)
    {
      f[j]=0;hh[j]=0;line[j]=0;lineLW[j]=0;mm[j]=0;lineADC[j]=0;HVset[j]=0;HVset2[j]=0;HVset3[j]=0;c16[j]=0;
    };
  c1->cd();
  c2->Print("mvse.ps(");
  c1->Print("adc.ps(");
  c2->Divide(4,4);
  c1->Divide(4,4);
  c1->SetLogy();
  c1->cd();
  int cnt=0;
  //  TObjArray* newSheets=new TObjArray(2000);
  Sheet* Sh=0;
  for(int det = 0;det<4;det++)
    {
      for(int ro=0;ro<rr[det];ro++)
	{
	  for(int co=0;co<rr[det]/2;co++)
	    {
	      if(cnt>15)
		{
		  Float_t pulserADC=0;
		  c1->Update();
		  c1->Print("adc.ps");
		  cnt=0;
		  c1->Clear();
		  c1->Divide(4,4);
		  c2->Update();
		  c2->Print("mvse.ps");
		  c2->Clear();
		  c2->Divide(4,4);
		};
	      printf("start deletes\n");
	      if(mm[cnt]){delete mm[cnt];mm[cnt]=0;};
	      if(hh[cnt]){delete hh[cnt];hh[cnt]=0;};
	      if(f[cnt]){delete f[cnt];f[cnt]f[=0;};
	      if(c16[cnt]){delete c16[cnt];c16[cnt]=0;};
	      if(line[cnt]){delete line[cnt];line[cnt]=0;};
	      if(lineLW[cnt]){delete lineLW[cnt];lineLW[cnt]=0;};
	      if(lineADC[cnt]){delete lineADC[cnt];lineADC[cnt]=0;};
	      if(HVset[cnt]){delete HVset[cnt];HVset[cnt]=0;};
	      if(HVset2[cnt]){delete HVset2[cnt];HVset2[cnt]=0;};
	      if(HVset3[cnt]){delete HVset3[cnt];HVset3[cnt]=0;};
	      printf("end deletes\n");


	      c1->cd(cnt+1);
	      c[ro][co][det]=0;
	      if(Legal(2,det+1,ro,co))
		{
		  char s[200];
		  sprintf(s,"Cellr%d_c%d_%d",ro,co,det);
		  cout<<s<<"\n";
		  char sf[200];
		  sprintf(sf,"data2/_%s.root",s);
		  printf("%s\n",sf);
		  f[cnt]=new TFile(sf);
		  if(f[cnt]==0)printf("open failed\n");

		  char shc[200];
		  sprintf(shc,"Shr%d_c%d_%d",ro,co,det);
		  printf("Getting %s \n",shc);
		  CalibStr* Rank=0;
		  if(f[cnt])
		    {
		      
		      Sh=(Sheet*) to->FindObject(shc);
		      Rank=(CalibStr*) f[cnt]->Get("Rank");
		      c[ro][co][det]=(Cell*) f[cnt]->Get(s);
		      c16[cnt]=c[ro][co][det];
		      printf("ok1\n");
		      TH2F* mmt=(TH2F*) f[cnt]->Get("mvse");
		      printf("ok2\n");
		      f[cnt]->ls();
		      printf("%x\n",mmt);
		      if(mmt)
			{
			  cout<<mmt->GetTitle()<<"\n";
			  mm[cnt]=new TH2F(*mmt);
			}
		      else
			{
			  mm[cnt]=new TH2F("missing","missing",100,0,50.,10,0.,.5);
			};
		      c2->cd(cnt+1);
		      if(mm[cnt])mm[cnt]->Draw("box");
		      c2->Update();
		      c1->cd(cnt+1);
		      if(c[ro][co][det])
			{
			  TString nam=c[ro][co][det]->GetName();
			  Float_t gcorr=FpdCorr->GetValue(2,det+1,ro,co);
			  Float_t gain=c[ro][co][det]->gain;
			  char gsg[100];
			  sprintf(gsg,"gcorr=%f5.3",gcorr);
			  nam=nam+gsg;
			  cout<<"zzzzTitle="<<nam;
			  cout<<nam<<"\n";
			  hh[cnt]=new TH1D(*(c[ro][co][det]->p_adcLed) );
			  if(hh[cnt])
			    {
			      if(hh[cnt]->GetEntries()<10)
				{
				  delete hh[cnt];
				  hh[cnt]=new TH1D(*(c[ro][co][det]->p_adc));
				};
			    }
			  else
			    {
			      hh[cnt]->SetLineColor(2);
			    };
			  hh[cnt]->SetTitle(nam);
			  mm[cnt]->SetTitle(nam);
			  Float_t gn2=gain*gcorr;
			  if(gn2>100./4000)
			    {
			      Float_t a100=100/gn2;
			      //     hh[cnt]->GetXaxis()->SetRangeUser(1,a100);
			    };
			  Float_t sz=hh[cnt]->GetXaxis()->GetLabelSize()*2;
			  hh[cnt]->GetXaxis()->SetLabelSize(sz);
			  hh[cnt]->GetXaxis()->SetRangeUser(1,5000);
			  //			  hh[cnt]->Draw();

			  Float_t maxh=hh[cnt]->GetMaximum()*1.5;

			  hh[cnt]->GetYaxis()->SetRangeUser(1,maxh);

			  gg=c[ro][co][det]->p_adc;
			  gg->SetTitle(nam);
			  gg->Draw();

			  if( gn2<1./4000 && gg->Integral(1000,4000)<2)
			    {
			      if(gg->Integral(100,4000)<2)
				{
				  if(maxh<50)maxh=50;
				  hh[cnt]->SetMaximum(50.);
				    //  hh[cnt]->GetXaxis()->SetRangeUser(0,100);
				};
			      
			    };
			  Int_t shift=0;

			  if(Sh)
			    {
			      Sh->HVfactor=1.;
			      if(Sh->GetGr())
				{
				  TF1* fitfun=Sh->GetGrFun();
				  if(fitfun)
				    {
				      //get HvSet from nominal Sheet value
				      Float_t HvSet=fabs(Sh->HVsetValue);
				      
				      if(Sh->GetHistory())HvSet=Sh->GetHV(false);
				      //     Set HVsetValue to last history old value
				      Sh->HVsetValue=HvSet;
				      shift=0;
				      if(Rank)
					{
					  //  shift=Rank->GetValue(2,det+1,ro,co);
					  //  printf("Rank=%x\n",shift);
					  // shift=shift&0x1f;
					  // shift+=1;
					}
				      //get the old shift from recent history
				      shift=Sh->Getshift(false);
				      printf("Old shift=%4d \n",shift);
				      //get Pulser ADC from HvSet and old shift
				      pulserADC=fitfun->Eval(HvSet)*pow(2,shift);
				      
				      printf("%s HvSet=%f pulser= %f \n", 
					     Sh->GetName(),HvSet,pulserADC);
				    }
				};
			    };
			  
			  if(hh[cnt]->Integral(0,4000)>2)
			    {
			      c1->GetPad(cnt+1)->SetLogy();
			      c1->GetPad(cnt+1)->SetLogx();
			    };
			  Float_t max=hh[cnt]->GetMaximum();
			  //			  c[ro][co][det]->p_adc->Draw("same");
			  //			  hh[cnt]->Draw("same");
			  //gn2 is GeV/cnt from standing calibration
			  if(gn2>0)
			    {
			      cout<<gg->GetTitle()<<"\n";
			      Float_t LWt=LogWt(gg);
			      cout<<"Log wghted Mean = "<<LWt<<"\n";
			      Float_t a10=10/gn2;
			      line[cnt]=new TLine(a10,0.,a10,1.5*max);
			      Float_t ggcor=gcorbyTrig(gg,300,10);
			      cout<<"ggcor="<<ggcor<<"\n";
			      if(ggcor<=0)
				{
				  ggcor=.00001;
				  cout<<" now ggcor="<<ggcor<<"\n";
				};
			      pulserADC=10/ggcor;
			      lineADC[cnt]=new TLine(pulserADC,0.,pulserADC,1.5*max);
			      lineLW[cnt]=new TLine(LWt,0.,LWt,1.5*max);
			      
			      lineLW[cnt]->SetLineColor(2);
			      
			      line[cnt]->SetLineColor(6);
			      lineADC[cnt]->SetLineColor(4);
			      line[cnt]->Draw("same");
			      lineLW[cnt]->Draw("same");
			      lineADC[cnt]->Draw("same");
			      char hvch[100];
			      sprintf(hvch,"High V=%4.0f shft=%2.0f",HvSet,shift);
			      if(det>1)sprintf(hvch,"High V=%2x shft=%2.0f",HvSet,shift);
			      printf("HvSet=%d %s=hvch\n",HvSet,hvch);
			      HVset[cnt]=new TText(.1,pow(max,.5),hvch);
			      HVset[cnt]->SetTextColor(3);
			      HVset[cnt]->SetTextSize(.08);
			      HVset[cnt]->Draw();
			      if(Sh)
				{
				  cout<<Sh->StringHistory()<<"\n";
				  // ishift is old nominal shift
				  Int_t ishift=shift;

				  printf("ishift=%d\n",ishift);
				  Int_t ishift0=-ishift;
				  //ishift0+ishift is zero (zero shift) 
				  Float_t newHv=fabs(Sh->HvScale(gcorr,0));
				  printf("inithi0v%dr%d_c%d_%d v=%d shift=%d \n",0,ro,co,det,newHv,ishift);

				  newHv=fabs(Sh->HvScale(gcorr,-ishift0));
				  printf("hi0v%dr%d_c%d_%d vold=%f vnew=%d shift=%d \n",0,ro,co,det,Sh->HVsetValue,newHv,ishift+ishift0);
				  Float_t hvmax[4]={1600,1600,255,255};
				  Float_t hvmin[4]={1100,1100,1,1};
				  for(int jj=0;jj<7;jj++)
				    {
				      if(newHv>hvmax[det])
					{
					  if(ishift+ishift0<6)
					    {
					      ishift0=ishift0+1;
					      newHv=fabs(Sh->HvScale(gcorr,-ishift0));
					    };
					  printf("Downshift:hiv%dr%d_c%d_%d vnew=%d ishift0=%d \n",jj,ro,co,det,newHv,ishift+ishift0);
					};
				      if(newHv<hvmin[det])
					{
					  if(ishift0+ishift>-6)
					    {
					      ishift0=ishift0-1;
					      newHv=(Sh->HvScale(gcorr,-ishift0));
					    };
					  printf("Upshift::hiv%dr%d_c%d_%d vnew=%d ishift0=%d \n",jj,ro,co,det,newHv,+ishift+ishift0);
					};
				    }
				  printf("hiv%dr%d_c%d_%d v=%d ishift0=%d \n",jj,ro,co,det,newHv,ishift+ishift0);
				  
				  sprintf(hvch,"High V=%4.0f shft=%d",newHv,ishift+ishift0);
				  if(det>1)
				    {
				      sprintf(hvch,"High V=%4x shft=%d",newHv,ishift+ishift0);
				      if(newHv<0)
					sprintf(hvch,"High V=%3d shft=%d",newHv,ishift+ishift0);
				    };
				  if(Sh->HVsetValue!=0)
				    Sh->HVfactor=fabs(((Float_t) newHv)/((Float_t) Sh->HVsetValue));
				  Sh->AddHistory((Float_t) Sh->HVsetValue,(Float_t) newHv,gcorr,1.,ishift,ishift+ishift0);
				  printf("HVfactor=%f\n",Sh->HVfactor);
				  
				  HVset2[cnt]=new TText(.1,pow(max,.4),hvch);
				  HVset2[cnt]->SetTextColor(7);
				  HVset2[cnt]->SetTextSize(.08);
				  HVset2[cnt]->Draw();
				  if(Sh->GetGrFun())
				    {
				      Float_t chi2 =Sh->GetGrFun()->GetChisquare();
				      Float_t NDF=(Float_t) Sh->GetGrFun()->GetNDF();
				      Float_t chi2d=-1;
				      if(NDF>2)chi2d=chi2/NDF;
				      sprintf(hvch,"chi/N =%6.0f NDF=%3.0f",chi2d,NDF);
				      HVset3[cnt]=new TText(.1,pow(max,.3),hvch);
				      HVset3[cnt]->SetTextColor(7);
				      HVset3[cnt]->SetTextSize(.08);
				      HVset3[cnt]->Draw();
				    };
				};
			    };
			  c1->Update();
			  c2->Update();
			}
		      
		    };
		  
		  cnt++;
		  c1->GetPad(cnt)->GetFrame()->SetFillColor(16); 
		}
	    };
	}
    }
  FILE* fp1;
  FILE* fp2;
  FILE* fp3;
  FILE* fp4;
  FILE* fp5;
  FILE* fp6;
  FILE* qtfp[4];
  
  fp1=fopen("txt/HV1.set","w");
  fp2=fopen("txt/HV2.set","w");
  fp3=fopen("txt/HV3.set","w");
  fp4=fopen("txt/HV4.set","w");
  fp5=fopen("txt/HV5.set","w");
  fp6=fopen("txt/HV6.set","w");
  qtfp[0]=fopen("txt/QT1.dat","w");
  qtfp[1]=fopen("txt/QT2.dat","w");
  qtfp[2]=fopen("txt/QT3.dat","w");
  qtfp[3]=fopen("txt/QT4.dat","w");
  TIter next(to);
  Sheet* psh;
  Int_t id1old=-1;
  Int_t id2old=-1;
  Int_t id3old=-1;
  Int_t id4old=-1;
  Bool_t nw=false;
  while(psh=(Sheet*) next())
    {
      if(fabs(psh->HVfactor)>.0001)
        {
	  Int_t id1=psh->id1;
	  Int_t id2=psh->id2;
	  Int_t id3=psh->id3;
	  Int_t id4=psh->id4;
          if(psh->id1==7005)fprintf(fp1,"%s",(char*) psh->SetCommand(7,nw)) ;
          if(psh->id1==7006)fprintf(fp2,"%s",(char*) psh->SetCommand(7,nw)) ;
          if(psh->id1==7007)fprintf(fp3,"%s",(char*) psh->SetCommand(7,nw)) ;
          if(psh->id1==7008)fprintf(fp4,"%s",(char*) psh->SetCommand(7,nw)) ;
	  int Comarg=4;
	  if(id1!=id1old)Comarg=5;
	  if(id2!=id2old || id3!=id3old)Comarg=Comarg+2;
	    
          if(psh->nstb1==3)fprintf(fp5,"%s",(char*) psh->SetCommand(Comarg,nw)) ;
          if(psh->nstb1==4)fprintf(fp6,"%s",(char*) psh->SetCommand(Comarg,nw)) ;
	  id1old=id1;
	  id2old=id2;
	  id3old=id3;
	  id4old=id4;
	  Int_t qtcrate=psh->QTCrate;
	  if(qtcrate>0 && qtcrate<5 )
	    {
	      if(psh->Getshift(nw)!=0)
		{
		  cout<<psh->QTline();
		  cout<<"qtcrate="<<qtcrate<<" "<<psh->chan1<<"\n";
		  fprintf(qtfp[qtcrate-1],"\# chan=%d\n",psh->chan1);
		  fprintf(qtfp[qtcrate-1],"%s",(const char*) psh->QTline(nw));
		}
	    }
	  else
	    {
	      fprintf(qtfp[0],"#looking for QT%d\n",qtcrate);
	    };
	}
    }
  c1->Print("adc.ps)");
  c2->Print("mvse.ps)");
  system("ps2pdf adc.ps;rm adc.ps;ps2pdf mvse.ps; rm mvse.ps");
}
