void PrintCorr(TString set="small")
{  
  gROOT->LoadMacro("Legal.C");
  Int_t nstb0=1;
  if(set == TString("small"))nstb0=3;
  TString str=gSystem->ExpandPathName("$SETFMSENV");
  if(str!="SETFMSENV"){printf("source SetFMSEnv first");exit();};
  
  gROOT->Reset();
  gSystem->Load("${FMSSRC}/Fpdchan.so");

  gStyle->SetPalette(1);
  TString dir("data2/");
  gStyle->SetOptStat(0);

  TFile* Fpd=new TFile("FpdFile.root");
  Bool_t ReplaceFpd=false;
  if(Fpd)ReplaceFpd=true;
  int ver=1;  
  CalibStr* FpdCorr=0;
  CalibStr* FpdCnew=0;
  char strver[100];
  sprintf(strver,"FpdCorrV%d",ver);
  cout<<strver<<"\n";
  while(FpdCnew=(CalibStr*) Fpd->Get(TString(strver)))
    {		
      FpdCorr=FpdCnew;
      FpdCorr->filename="FpdCorr.txt";
      FpdCorr->OutName="FpdCorr.txt";
      
      ver++;
      sprintf(strver,"FpdCorrV%d",ver);
      cout<<strver<<"\n";
    };
  if(!FpdCorr)exit;
  CalibStr* FpdGain=Fpd->Get("FpdGain");
  Int_t Nr=24;
  if(nstb0<3)Nr=34;
  Int_t Nr2=Nr/2;

  TH2F hgain("hgain","hgain",Nr,-Nr2,Nr2,Nr,0,Nr);
  TH2F hcor1("hcor1","hcor1",Nr,-Nr2,Nr2,Nr,0,Nr);
  TH2F hcor2("hcor2","hcor2",Nr,-Nr2,Nr2,Nr,0,Nr);
  for(int r=0;r<Nr;r++)
    {
      for(int c=0;c<Nr2;c++)
	{
	  Float_t gn3=FpdGain->GetValue(2,nstb0,r,c);
	  Float_t gn4=FpdGain->GetValue(2,nstb0+1,r,c);
	  Float_t cr3=FpdCorr->GetValue(2,nstb0,r,c);
	  Float_t cr4=FpdCorr->GetValue(2,nstb0+1,r,c);
	  if(!Legal(2,nstb0,r,c)){gn3=cr3=0;};
	  if(!Legal(2,nstb0+1,r,c)){gn4=cr4=0;};
	  int bin=hgain.FindBin(c+.5,r+.5);
	  hgain.SetBinContent(bin,gn4);
	  hcor1.SetBinContent(bin,cr4);
	  int bin=hgain.FindBin(-(c+.5),(r+.5));
	  hgain.SetBinContent(bin,gn3);
	  hcor1.SetBinContent(bin,cr3);
	};
    };

  TCanvas* c1=new TCanvas("c1","c1",600,800);
  c1->Divide(1,2);
  c1->cd(1);
  c1->GetPad(1)->SetLogz();

  hcor1.SetMarkerSize(.6);
  TString titl="FpdCorr ";
  titl=titl+set;
  hcor1.SetTitle((char*) titl);
  hcor1.SetMaximum(2.);
  hcor1.SetMinimum(.5);
  hcor1.Draw("zcol");
  hcor1.Draw("textsame");
  c1->cd(2);

  hgain.SetMarkerSize(.8);
  TString titl="FpdGain ";
  titl=titl+set;
  
  hgain.SetTitle((char*) titl);
  hgain.Draw("text");

  c1->Update();
  system("sleep 5");
  TString file=set;
  file=file+"Plots/Fpdcorr.pdf";
  c1->Print(file);

};
