void SetRank(TString set="small" )
{ 
  TString str=gSystem->ExpandPathName("$SETFMSENV");
  if(str!="SETFMSENV"){printf("source SetFMSEnv first");exit();};
  
  gROOT->Reset();
  gSystem->Load("${FMSSRC}/Fpdchan.so");
  Int_t Nrows[4]={34,34,24,24};
  gROOT->LoadMacro("Legal.C");
  Int_t nstb0=1;
  if(set == TString("small"))nstb0=3;
  int nRows=34;
  if(nstb0>2)nRows=24;

  TString dir("data2/");
  TCanvas* c3=new TCanvas("c3","c3",600,800);
  TCanvas* c2=new TCanvas("c2","c2",600,800);
  c2->Divide(1,2);


  TFile* Fpd=new TFile("FpdFile.root");
  Bool_t ReplaceFpd=false;
  if(Fpd)ReplaceFpd=true;
  int ver=1;  
  CalibStr* FpdCorr=0;
  CalibStr* FpdCnew=0;
  TString sver="1";
  while(FpdCnew=(CalibStr*) Fpd->Get(TString("FpdCorrV")+sver))
    {		
      FpdCorr=FpdCnew;
      FpdCorr->filename="FpdCorr.txt";
      FpdCorr->OutName="FpdCorr.txt";
      ver++;
      sver=ver;
    };
  if(!FpdCorr)exit;
  FitTower::Setwe_ab(0.8,.3,-.1,.8,.2,7.6);//Nominal Shower Shape
  Cell* cell[34][17][4];
  for(int r1=0;r1<34;r1++){for(int c1=0;c1<17;c1++){for(int k1=0;k1<4;k1++)
	{cell[r1][c1][k1]=0;}}};
  TFile* fl=new TFile("Output.root","Update");
  TObjArray* mycells=(TObjArray*)  fl->FindKey("Mycells")->ReadObj();
  TIter next(mycells);
  Cell* c;
  TTree* atr=0;
  tpCellRec* rc=0;
  CalibStr* Rank=new CalibStr(9100000,"Rank.txt");
  (*(Rank->tm(2,1)))=-1;
  (*(Rank->tm(2,2)))=-1;
  (*(Rank->tm(2,3)))=-1;
  (*(Rank->tm(2,4)))=-1;

  TH2F* mvse=new TH2F("mvse","mvse",100,0,100,40,0.,.4);
  
  while(c=(Cell*) next())
    {
      if(Legal(2,c->Instb,c->Row1-1,c->Col1-1))
	{
	  cell[c->Row1-1][c->Col1-1][c->Instb-1]=c;
	  int rnk=-1;
	  if(c)rnk=c->RankCell(Rank);
	  printf("Pass1: row=%d col=%d nstb=%d rank=%d\n",c->Row1,c->Col1,c->Instb,rnk);
	}
      
    };
  TIter nex(mycells);
  while(c=(Cell*) nex())
    {
      cell[c->Row1-1][c->Col1-1][c->Instb-1]=c;
      int Q=-1;
      c->Quality(Rank);
      if(c)rnk=Rank->GetValue(2,c->Instb,c->Row1-1,c->Col1-1);
      printf("Pass2: row=%d col=%d nstb=%d rank=%d Q=%x \n",c->Row1,c->Col1,c->Instb,rnk,Q);
    };
  gStyle->SetPalette(1);
  gStyle->SetOptStat(0);
  int pass=1;
  TMatrix* prm[4];
  prm[0]=new TMatrix(*(Rank->tm(2,1)));
  prm[1]=new TMatrix(*(Rank->tm(2,2)));
  prm[2]=new TMatrix(*(Rank->tm(2,3)));
  prm[2]->Print();
  prm[3]=new TMatrix(*(Rank->tm(2,4)));
  prm[3]->Print();
  /*
  TH2F Qdisp("QDisp","QDisp",24,-12,12,24,0,24);
  TH2F QNum("QNum","QNum",   24,-12,12,24,0,24);
  */
  TH2F Qdisp("QDisp","QDisp",nRows,-nRows/2,nRows/2,nRows,0,nRows);
  TH2F QNum("QNum","QNum",  nRows,-nRows/2,nRows/2,nRows,0,nRows);
  //large only ....
  int screen=0;
  
  for(int ns=nstb0-1;ns<nstb0+1;ns++)
    {
      screen++;
      printf("ns=%d \n",ns);
      int Nro=prm[ns]->GetNrows();
      int Nco=prm[ns]->GetNcols();
      printf("Nro=%d Nco=%d \n",Nro,Nco);
      for(int ro=0;ro<Nro;ro++)
	{
	  for(int co=0;co<Nco;co++)
	    {
	      float mcol=co+.5;
	      if(ns%2==0)mcol=-mcol;
	      float mrow=ro+.5;
	      float dval=Nrows[ns]/2-1.;
	      float nval=0;
	      int bin=Qdisp.FindBin(mcol,mrow);
	      if( (*(prm[ns]))[ro][co]==-1)(*(prm[ns]))[ro][co]=0;
	      printf("___(%d, %d,%d)=%x",ns,ro,co,(int) (*(prm[ns]))[ro][co]);
	      int iz0=(int) (*(prm[ns]))[ro][co];
	      if((0xFF&iz0)==0)
		{
		  dval=0;
		  nval=0;
		}
	      else
		{
		  if(iz0&0xFF)nval=iz0&0xFF;
		  if(nval==128)nval=0;
		  if(iz0&0xFFF00)
		    {

		      if(0xFF000)dval=8;
		      if(0xF00)dval=3;
		    }
		  else
		    {
		      dval=10;
		      nval==0;
		    };
		};
	      if(abs(ro-(Nrows[ns]/2.+.5))<1 && dval==10)dval=9; 
	      if(!Legal(2,ns+1,ro,co))
		{
		  dval=0;
		  nval=0;
		};
	      Qdisp.SetBinContent(bin,dval);
	      QNum.SetBinContent(bin,nval);
	      printf("bin=%d dval=%d nval=%d \n",bin,dval,nval);
	      int iz=iz0 & 0xFF;
	      if(iz==128)iz=1000;
	      if(iz0&0x100)iz=iz+10000;
	      if(iz0&0x1000)iz=iz+100000;
	      if(iz0&0x10000)iz=iz+1000000;
	      if(!Legal(2,ns+1,ro,co))iz=0;
	      (*(prm[ns]))[ro][co]=iz;
	      printf("->%d\n",(int) (*(prm[ns]))[ro][co]);
	    };
	};
      c2->cd(screen);
      printf("c2->cd(%d-1)\n",screen);
      Rank->tm(2,ns+1)->Print("text");
      prm[ns]->Draw("text");
      c2->Update();

    };
  c2->Clear();
  Qdisp.SetMaximum(11);
  QNum.SetMaximum(33);
  Qdisp.Draw("zcol");
  c3->cd();
  QNum.Draw("text");
  c3->Update();
  c2->cd();
  QNum.Draw("textsame");
  TString file=set;
  file=file+"Plots/CellQuality.pdf";
  c2->Print(file);

  for(int ns=nstb0;ns<nstb0+2;ns++)
    {
      for(int row=1;row<=nRows;row++){for(int col=1;col<=(nRows/2);col++)
	  {
	    printf("now:%d %d %d  \n",row,col,ns);
	    c=cell[row-1][col-1][ns-1];
	    if(c)
	      {
		if(!Legal(2,ns,row-1,col-1))
		  {
		    printf("!Legal: r%d c%d %d  \n",row,col,ns);
		  }
		else
		  {
		    TString fname(dir);
		    fname=fname+"_"+c->GetName()+".root";
		    printf(" %s\n",(const char*)fname);
		    TFile flout(fname,"update");
		    flout.ls();
		    printf("ranksum=%d %d %d %d \n",
			   Rank->tm(2,1)->Sum(),
			   Rank->tm(2,2)->Sum(),
			   Rank->tm(2,3)->Sum(),
			   Rank->tm(2,4)->Sum()),
		    Rank->Write("Rank");
		    flout.Close();
		    printf("close flout\n");
		  };
	      }
	    else 
	      {
		printf("no call r%d c%d d%d not defined\n",row,col,ns);
	      };
	  };
	printf("pass %d done\n",pass);
      };
    };
};
