{
  gROOT->Macro("start.C");
  gROOT->LoadMacro("ChiCPD.C");
  Float_t pol=.5;
  Float_t pcos=1./pol/.7;
  TCanvas* c1=new TCanvas("c1","c1",600,600);
  TChain* TwoTr=new TChain("TwoTr");
  TwoTr->Add("../Output/Outputset0*.root");
  TH1D* h[200];
  TF1* fh[200];
  TLine* lnl[200];
  TLine* lnh[200]; 
  Float_t lowpt[3]={1.5,2.0,3.};
  Float_t hipt[3]={7.,8.,10.};

  Int_t cnt=0;
  TFile* ffout=new TFile("SpinAnal/newfout80.root");
  TFile* fout=new TFile("FitTest.root","recreate");
  TString psname="Fplots.ps";
  Float_t an=0;
  Float_t dan=0;
  Float_t chi2=100.;
  Int_t NDF;
  Int_t offset=0;
  Float_t lolim=.02;
  Float_t hilim=.4;

  char cfout[200];
  char cfout2[200];
  char cfouty[200];
  char hname[200];
  char hnameY[200];
  char cutname[300];
  float ene;
  int enecnt=0;
  int iofs=0;
  Float_t ebin[8]={10,30,50,70,90,110,130,150};
  TString  hexset="7fffffffffff8";
  hexset="7fffffffffff8";
  hexset="7ffffffffffff";
  c1->Print(psname+"(");
  char* Hnames[10][2]=
    {{"Full FMS","FMSall"},
     {"Mpi Z  Eaway>50","FMS50"},
     {"Z<.7&& N12==2 && Ntracks>2 && abs(NE-E12)<20&&abs(M12-.21)<.19","FMS20"},
     {"Ntracks==2","FMSNtr2"},
     {"Dcphi<-.5 && DE<10","FMSplane"},
     {"Dcphi<-.5 && DE-15<10","FMSplane15_10"},
     {"abs(Dcphi)<.5 && DE-15<10","FMSPerp15_10"},
     {"Dcphi>.0 && DE-15<10","FMSsame15_10"},
     {"Ccphi<0. && DE-15<10 ","FMShplane15_10"},
     {"Ccphi<0. && DE-15<10 && MawayPi","FMSawayPihplane15_10"}
    };
  TF1* fun=0;
  enecnt=45;
  gStyle->SetOptFit();
  TF1* lfun=new TF1("lfun","[0]+[1]*x",-1,1.);
  TGraphErrors grlum;
  Float_t Ebins[3]={50,70,90};
  for(int kcnt=2;kcnt<7;kcnt+=2)
    {
      c1->Divide(2,1);
      iofs=(kcnt/2-1);
      c1->cd(1);
      sprintf(cfout,"DirCcut%dset%s_nb10_f0",enecnt+iofs,(const char*) hexset);
      sprintf(cfout2,"DirCcut%dset%s_nb10_f0Y",enecnt+iofs,(const char*) hexset);
      cout<<cfout<<"\n";
      char hnam2[200];
      char hnam2Y[200];
      sprintf(hnam2,"CosPhiEtacut%dE%2.0f",enecnt+iofs,ebin[2+iofs]);
      sprintf(hnam2Y,"CosPhiEtacut%dE%2.0fY",enecnt+iofs,ebin[2+iofs]);
      TH1F* Asm=0;
      TH1F* AsmY=0;
      if(ffout->Get(cfout))
	Asm=(TH1F*) ((TDirectory*) ffout->Get(cfout))->Get("Asm");
      if(ffout->Get(cfout2))
	AsmY=(TH1F*) ((TDirectory*) ffout->Get(cfout2))->Get("Asm");
      if(Asm)
	{
	  c1->cd(1);
	  Asm->GetYaxis()->SetLabelSize(.03);
	  Asm->GetYaxis()->SetTitleOffset(1.3);
	  Asm->SetName(hnam2);
	  Asm->Scale(1./pol);
	  Asm->Fit("pol1","","",-1.,1.);
	  Asm->GetYaxis()->SetRangeUser(-.05,.075);
	  Asm->SetLineColor(4);
	  Asm->GetYaxis()->SetTitle("AN (pol=.5)");
	  Asm->Draw();
	  Asm->Write(hnam2);
	  int grcnt=grlum.GetN();
	  grlum.SetPoint(grcnt,Ebins[iofs],
			 Asm->GetFunction("pol1")->GetParameter(0));
	  grlum.SetPointError(grcnt,10,
			 Asm->GetFunction("pol1")->GetParError(0));
	};
      if(AsmY)
	{
	  c1->cd(2);
	  AsmY->GetYaxis()->SetLabelSize(.03);
	  AsmY->GetYaxis()->SetTitleOffset(1.3);
	  AsmY->SetName(hnam2);
	  AsmY->Scale(1./pol);
	  AsmY->GetYaxis()->SetTitle("AN (pol=.5)");
	  AsmY->Fit("pol1","","",-1.,1.);
	  AsmY->GetYaxis()->SetRangeUser(-.05,.075);
	  AsmY->SetLineColor(5);
	  
	  AsmY->Draw();
	  
	  TPaveStats* Ast=(TPaveStats*) AsmY->FindObject("stats");
	  AsmY->Draw("same");
	  
	  AsmY->Write(hnam2Y);
	};
      c1->Print(psname);
      c1->Clear();
    };
  grlum->Draw("A*");
  grlum->Fit("pol0");
  c1->Print(psname);
  Float_t LuminosityRatio=grlum->GetFunction()->GetParameter(0);
  Float_t LuminosityRatioY=-.0045;
  c1->Divide(2,3);
   //-------------------------------
  for (enecnt=45;enecnt<55;enecnt++)
    {
      sprintf(cutname,"%s",Hnames[enecnt-45][0]);
      sprintf(cfout,"DirEdcut%dset%s_nb15",enecnt,(const char*) hexset);
      sprintf(hname,"%s",Hnames[enecnt-45][1]);
      cout<<"dir="<<cfout<<"\n";
      TH1F* CRat=0;
      if(ffout->Get(cfout))
	{
	  
	  CRat=(TH1F*) ((TDirectory*) ffout->Get(cfout))->Get("CrossRat");
	  cout<<CRat->GetTitle()<<"\n";
	  CRat->Scale(pcos);
	  CRat->GetYaxis()->SetTitle("Cross AN (<cos>=.7 pol=.5)");
	  CRat->GetYaxis()->SetRangeUser(-.03,.120);
	  if(enecnt==45)      CRat->GetYaxis()->SetRangeUser(-.01,.060);
	  CRat->GetXaxis()->SetRangeUser(0.,95.);
	  CRat->SetStats(0);
	  CRat->GetYaxis()->SetLabelSize(.03);
	  CRat->GetYaxis()->SetTitleOffset(1.3);
	  CRat->Draw();
	  
	  if(enecnt==45)
	    {
	      CRat->Fit("pol2","","",20,100);
	      fun=CRat->GetFunction("pol2");
	      TLine line(0.,0.,95.,0.);
	      line.Draw("same");
	      TText txt(10.,.1,cutname);
	      txt->SetTextSize(.02);
	      txt->Draw("same");
	    }
	  else
	    {
	      fun->Draw("same");
	      TLine line(0.,0.,95.,0.);
	      line.Draw("same");
	      TText txt(10.,.1,cutname);
	      txt->SetTextSize(.02);
	      txt->Draw("same");
	    }
	};
      c1->Print(psname );
      c1->Write(hname);
    };

  //-----------------------
  int etacnt=0;
  enecnt=0;
  int binvec[2]={12,96};
  printf("start bset\n");
  for( int bset=0;bset<2;bset++)
    {
      enecnt=0;
      for(ene=50;ene<100;ene+=20)
	{
	  c1->Clear();
	  sprintf(cutname," energy=%3.2f ",ene);
	  printf("%s\n",cutname);
	  sprintf(cfout,"Dir5bcut%dset%s_nb%d",enecnt,(const char*) hexset,binvec[bset]);
	  printf("%s \n",cfout);
	  sprintf(hname,"Ebcut%d_%d",enecnt,bset);
	  
	  enecnt+=12; 
	  if(ffout->Get(cfout))
	    {
	      TDirectory* dir=(TDirectory*) ffout->Get(cfout);
	      if(!dir){ printf("directory not found\n");return;};
	      dir->pwd();
	      CrossRat=(TH1F*) (dir->Get("CrossRat"));
	      if(CrossRat==0)
		{
		  
		  printf("CrossRat not found in %s \n",cfout);
		  //	      ffout->ls();
		  //	      ffout->((TDirectory*) ffout->Get(cfout))->ls();
		  return;
		};
	      
	      CrossRat->Scale(pcos);
	      CrossRat->GetYaxis()->SetTitle("Cross AN (<cos>=.7 pol=.5)");
	      CrossRat->GetYaxis()->SetRangeUser(-.03,.12);
	      CrossRat->GetXaxis()->SetRangeUser(0.,12.);
	      CrossRat->SetStats(0);
	      CrossRat->GetYaxis()->SetLabelSize(.03);
	      CrossRat->GetYaxis()->SetTitleOffset(1.3);
	      
	      CrossRat->Draw();
	      TLine line(0.,0.,15.,0.);
	      line.Draw("same");
	      TText txt(1.,.13,cutname);
	      txt->Draw("same");
	      c1->Update();
	      c1->Print(psname);
	      c1->Write(hname);
	    }    
	}
    };
  printf("ok encut now\n");
  //--------------------------
  
  Float_t encut[3]={50.,70.,90.};
  TGraphErrors ptGr[3];
  TGraphErrors pTGr[3];
  
  for(int knt=0;knt<30;knt++)
    {
      c1->Clear();
      c1->Divide(2,2);
      float y=3.5+knt*.02;
      TGraphErrors gr;

      for(int kknt=0;kknt<3;kknt++)
	{
	  c1->cd(kknt+1);
	  sprintf(cutname," Eta=%5.3f E=%5.3f",y,encut[kknt]);
	  sprintf(cfout,"DirC2cut%dset%s_nb10_f0",knt+kknt*30,(const char*) hexset);
	  sprintf(hname,"C2cut%d",knt+30*kknt);
	  if(ffout->Get(cfout))
	    {
	      TH1F* Asm3=(TH1F*) ((TDirectory*) ffout->Get(cfout))->Get("Asm");
	      Float_t pt=encut[kknt]*2*exp(-y);
	      if(Asm3!=0)
		{
		  
		  Asm3->Scale(1/pol);
		  Asm3->GetYaxis()->SetTitle("AN (pol=.5)");
		  Asm3->GetYaxis()->SetLabelSize(.03);
		  Asm3->GetYaxis()->SetTitleOffset(1.3);
		  Asm3->GetYaxis()->SetRangeUser(-.1,.1);
		  Asm3->SetName(hname);
		  TF1* lfn=new TF1("lfn","[0]+[1]*x",-1,1.);
		  lfn->FixParameter(0,LuminosityRatio);
		  lfn->SetParameter(1,.01);
		  Asm3->SetMarkerColor(2);
		  Asm3->Fit("lfn","","",-1.,1.);
		  Asm3->SetTitle(cutname);
		  Asm3->Draw();
		  Asm3->Write();
		  int gcnt=gr.GetN();
		  
		  an=dan=0;
		  chi2=100.;
		  Float_t energy=encut[kknt];

		  if(Asm3->GetFunction("lfn"))
		    {
		      an=Asm3->GetFunction("lfn")->GetParameter(1);
		      dan=Asm3->GetFunction("lfn")->GetParError(1);
		      chi2=Asm3->GetFunction("lfn")->GetChisquare();
		      if(chi2<50 )
			{
			  gcnt=gr.GetN();
			  gr.SetPoint(gcnt,energy,an);
			  gr.SetPointError(gcnt,0,dan);
			  
			  gcnt=ptGr[kknt].GetN();
			  ptGr[kknt].SetPoint(gcnt,pt,an);
			  ptGr[kknt].SetPointError(gcnt,0,dan);
			}
		    }
		};
	    };
	}
      c1->cd(4);
      gr.GetXaxis()->SetTitle("Energy Pair (GeV)");
      gr.GetYaxis()->SetTitle("AN (pol=.5)");
      gr.GetYaxis()->SetRangeUser(-.02,.1);
      gr.SetTitle("AN vs Energy from cos(phi) Fits");
      
      gr.Draw("A*");
      c1->Print(psname);
      
    };
  //---------------------------------
  TGraphErrors ptGp[3];
  TGraphErrors ptGpaff[3];
  TGraphErrors ptGpaffy[3];

  TH1F* Chi2_3_dof[4];
  Chi2_3_dof[0]= new TH1F("Chi2_3_dofa","Chi2/DOF 3a",30,0,3);
  Chi2_3_dof[1]= new TH1F("Chi2_3_dofb","Chi2/DOF 3b",30,0,3);
  Chi2_3_dof[2]= new TH1F("Chi2_3_dofc","Chi2/DOF 3c",30,0,3);

  TGraph grchi;
  Float_t dPt=.125;
  for(int j=1;j<30;j++)
    {
      float x=j*.1;
      float y=(ChiCPD(9,(x+.05)*9)-ChiCPD(9,(x-.05)*9));
      printf("x=%f ChiCPD=%f \n",x,y);
      grchi.SetPoint(j,x,y);
    };
  //-------------------------------
  for(int knt=0;knt<40;knt++)
    {
      printf("knt=%d \n",knt);
      c1->Clear();
      c1->Divide(2,2);

      float PT=1.25+knt*2.*dPt;
      TGraphErrors gr;

      for(int kknt=0;kknt<3;kknt++)
	{
	  printf("kknt=%d\n",kknt);
	  c1->cd(kknt+1);
	  sprintf(cutname," pT=%5.3f E=%5.3f",PT,encut[kknt]);
	  sprintf(cfout,"DirC3cut%dset%s_nb10_f0",knt+kknt*40,(const char*) hexset);
	  sprintf(hname,"C3cut%d",knt+40*kknt);
	  if(ffout->Get(cfout))
	    {
	      TH1F* Asm3=(TH1F*) ((TDirectory*) ffout->Get(cfout))->Get("Asm");
	      printf("got Asm3\n");
	      Float_t pt=PT;
	      Float_t energy=encut[kknt];

	      if(Asm3!=0)
		{
		  if( Asm3->GetEntries()>0)
		    {
		      printf("Asm3 ok\n");
		      Asm3->Scale(1/pol);
		      Asm3->GetYaxis()->SetTitle("AN (pol=.5)");
		      Asm3->GetYaxis()->SetLabelSize(.03);
		      Asm3->GetYaxis()->SetTitleOffset(1.3);
		      Asm3->GetYaxis()->SetRangeUser(-.1,.1);
		      Asm3->SetName(hname);
		      chi2=100.;
		      NDF=0;
		      an=dan=chi2=0;
		      chi2=100.;
		      if(Asm3->GetEntries()>2)
			{
			  TF1* lfn=new TF1("lfn","[0]+[1]*x",-1,1.);
			  lfn->FixParameter(0,LuminosityRatio);
			  lfn->SetParameter(1,.01);
			  Asm3->SetMarkerColor(2);
			  Asm3->Fit("lfn","","",-1.,1.);
			  if(Asm3->GetFunction("lfn"))
			    {
			      an=Asm3->GetFunction("lfn")->GetParameter(1);
			      dan=Asm3->GetFunction("lfn")->GetParError(1);
			      chi2=Asm3->GetFunction("lfn")->GetChisquare();
			      NDF=Asm3->GetFunction("lfn")->GetNDF();
			      if(NDF>0)Chi2_3_dof[kknt]->Fill(chi2/NDF);
			    }
			  else 
			    {
			      an=dan=chi2=0;
			    };
			};
		      Asm3->SetTitle(cutname);
		      Asm3->Draw();
		      Asm3->Write();
		      int gcnt=gr.GetN();
		      if(chi2<50)
			{
			  gr.SetPoint(gcnt,energy,an);
			  gr.SetPointError(gcnt,0,dan);
			  
			  gcnt=ptGp[kknt].GetN();
			  ptGp[kknt].SetPoint(gcnt,pt,an);
			  ptGp[kknt].SetPointError(gcnt,0,dan);
			  if(pt<4 && pt>lowpt[kknt])
			    {
			      gcnt=ptGpaff[kknt].GetN();
			      ptGpaff[kknt].SetPoint(gcnt,pt,an);
			      ptGpaff[kknt].SetPointError(gcnt,dPt+.02,dan);
			    }
			};
		    };
		};
	    }
	  printf("exit Asm3 ok loop\n");
	}
      c1->cd(4);
      printf("cd(4)\n");
      printf("N=%d\n",gr.GetN());
      if(gr.GetN()>0)
	{
	  gr.GetXaxis()->SetTitle("Energy pair (GeV)");
	  gr.GetYaxis()->SetTitle("AN (pol=.5)");
	  gr.GetYaxis()->SetRangeUser(-.02,.1);
	  gr.SetTitle("AN vs Energy from cos(phi) Fits");
	  printf("gr.Draw\n");
	  gr.Draw("A*");
	};
      c1->Print(psname);
      printf("print done\n");
    };
  c1->Clear();
  c1->Divide(2,2);
  for(int kknt=0;kknt<3;kknt++)
    {
      c1->cd(kknt+1);
      Chi2_3_dof[kknt]->Draw();
      Chi2_3_dof[kknt]->Write();
    }
  c1->cd(4);
  grchi.Draw("A*");
  c1->Print(psname);
  grchi.Write("CHI2_9_pdf");
  //----------------------


  TGraphErrors ptGpff[3];
  TGraphErrors ptGpffY[3];
  
  TH1F* Chi2_3ff_dof[4];
  Chi2_3ff_dof[0]= new TH1F("Chi2_3ff_dofa","Chi2/DOF 3a",30,0,3);
  Chi2_3ff_dof[1]= new TH1F("Chi2_3ff_dofb","Chi2/DOF 3b",30,0,3);
  Chi2_3ff_dof[2]= new TH1F("Chi2_3ff_dofc","Chi2/DOF 3c",30,0,3);

  dPt=.5;
  for(int knt=0;knt<10;knt++)
    {
      printf("knt=%d \n",knt);
      c1->Clear();
      c1->Divide(2,2);
      float PT=1.5+knt*2*dPt;
      TGraphErrors gr;
      TGraphErrors grY;

      for(int kknt=0;kknt<3;kknt++)
	{
	  char nameff[200];
	  sprintf(nameff,"ptGpff%d",kknt);
	  ptGpff.SetName(nameff);
	  sprintf(nameff,"ptGpffY%d",kknt);
	  ptGpffY.SetName(nameff);

	  printf("kknt=%d\n",kknt);
	  c1->cd(kknt+1);
	  sprintf(cutname,"ff: pT=%5.3f E=%5.3f",PT,encut[kknt]);
	  //	  sprintf(cfout,"DirC3f1fcut%dset%s_nb10_f0",knt+kknt*10,(const char*) hexset);
	  sprintf(cfout,"DirC3ffcut%dset%s_nb10_f0",knt+kknt*10,(const char*) hexset);
	  sprintf(cfouty,"DirC3ffcut%dset%s_nb10_f0Y",knt+kknt*10,(const char*) hexset);
	  sprintf(hname,"C3ffcut%d",knt+10*kknt);
	  if(ffout->Get(cfouty))
	    {
	      char hnameY[200];
	      sprintf(hnameY,"C3ffcut%dY",knt+10*kknt);
	      TH1F* Asm3ffY=(TH1F*) ((TDirectory*) ffout->Get(cfouty))->Get("Asm");
	      printf("got Asm3\n");
	      Float_t pt=PT;
	      Float_t energy=encut[kknt];
	      if(Asm3ffY!=0)
		{
		  if(Asm3ffY->GetEntries()>2)
		    {
		      Asm3ffY->Scale(1/pol);
		      Asm3ffY->GetYaxis()->SetTitle("AN (pol=.5)(ff)");
		      Asm3ffY->GetYaxis()->SetLabelSize(.03);
		      Asm3ffY->GetYaxis()->SetTitleOffset(1.3);
		      Asm3ffY->GetYaxis()->SetRangeUser(-.1,.1);
		      Asm3ffY->SetName(hname);
		      chi2=100.;
		      NDF=0;
		      
		      TF1* lfn=new TF1("lfn","[0]+[1]*x",-1,1.);
		      lfn->FixParameter(0,LuminosityRatioY);
		      lfn->SetParameter(1,.01);
		      Asm3ffY->SetMarkerColor(5);
		      Asm3ffY->Fit("lfn","","",-1.,1.);
		      if(Asm3ffY->GetFunction("lfn"))
			{
			  an=Asm3ffY->GetFunction("lfn")->GetParameter(1);
			  dan=Asm3ffY->GetFunction("lfn")->GetParError(1);
			  chi2=Asm3ffY->GetFunction("lfn")->GetChisquare();
			  NDF=Asm3ffY->GetFunction("lfn")->GetNDF();
			}
		      else 
			{
			  an=dan=chi2=0;
			};
		      if(chi2<60&& pt>lowpt[kknt]&& pt<hipt[kknt])
			{
			  
			  int gcnt=gr.GetN();
			  grY.SetPoint(gcnt,energy,an);
			  grY.SetPointError(gcnt,0,dan);
			  
			  gcnt=ptGpffY[kknt].GetN();
			  ptGpffY[kknt].SetPoint(gcnt,pt,an);
			  ptGpffY[kknt].SetPointError(gcnt,0,dan);

			  
			};
		    }
		};
	    };

	  if(ffout->Get(cfout))
	    {
	      TH1F* Asm3ff=(TH1F*) ((TDirectory*) ffout->Get(cfout))->Get("Asm");
	      printf("got Asm3\n");
	      Float_t pt=PT;
	      Float_t energy=encut[kknt];
	      
	      if(Asm3ff!=0)
		{
		  if( Asm3ff->GetEntries()>0)
		    {
		      printf("Asm3ff ok\n");
		      Asm3ff->Scale(1/pol);
		      Asm3ff->GetYaxis()->SetTitle("AN (pol=.5)(ff)");
		      Asm3ff->GetYaxis()->SetLabelSize(.03);
		      Asm3ff->GetYaxis()->SetTitleOffset(1.3);
		      Asm3ff->GetYaxis()->SetRangeUser(-.1,.1);
		      Asm3ff->SetName(hname);
		      chi2=100.;
		      NDF=0;
		      
		      if(Asm3ff->GetEntries()>2)
			{
			  TF1* lfn=new TF1("lfn","[0]+[1]*x",-1,1.);
			  lfn->FixParameter(0,LuminosityRatio);
			  lfn->SetParameter(1,.01);
			  Asm3ff->SetMarkerColor(2);
			  Asm3ff->Fit("lfn","","",-1.,1.);
			  if(Asm3ff->GetFunction("lfn"))
			    {
			      an=Asm3ff->GetFunction("lfn")->GetParameter(1);
			      dan=Asm3ff->GetFunction("lfn")->GetParError(1);
			      chi2=Asm3ff->GetFunction("lfn")->GetChisquare();
			      NDF=Asm3ff->GetFunction("lfn")->GetNDF();
			      if(NDF>0)Chi2_3ff_dof[kknt]->Fill(chi2/NDF);
			    }
			  else 
			    {
			      an=dan=chi2=0;
			    };
			};
		      Asm3ff->SetTitle(cutname);
		      Asm3ff->Draw();
		      Asm3ff->Write();
		      if(chi2<60)
			{
			  int gcnt=gr.GetN();
			  gr.SetPoint(gcnt,energy,an);
			  gr.SetPointError(gcnt,0,dan);
			  
			  gcnt=ptGpff[kknt].GetN();
			  ptGpff[kknt].SetPoint(gcnt,pt,an);
			  ptGpff[kknt].SetPointError(gcnt,0,dan);
			  if(pt>4 && pt<hipt[kknt])
			    {
			      gcnt=ptGpaff[kknt].GetN();
			      ptGpaff[kknt].SetPoint(gcnt,pt,an);
			      ptGpaff[kknt].SetPointError(gcnt,dPt+.02,dan);
			    }

			};
		    };
		};
	    }
	  printf("exit Asm3 ok loop\n");
	}
      c1->cd(4);
      printf("cd(4)\n");
      printf("N=%d\n",gr.GetN());
      if(gr.GetN()>0)
	{
	  gr.GetXaxis()->SetTitle("Energy pair (GeV)");
	  gr.GetYaxis()->SetTitle("AN (pol=.5)");
	  gr.GetYaxis()->SetRangeUser(-.02,.1);
	  gr.SetTitle("AN vs Energy from cos(phi) Fits (ff)");
	  printf("gr.Draw\n");
	  gr.Draw("A*");
	};
      c1->Print(psname);
      printf("print done\n");
    };
  c1->Clear();
  c1->Divide(2,2);
  for(int kknt=0;kknt<3;kknt++)
    {
      c1->cd(kknt+1);
      Chi2_3ff_dof[kknt]->Draw();
      Chi2_3ff_dof[kknt]->Write();
    }
  c1->cd(4);
  grchi.Draw("A*");
  c1->Print(psname);
  //----------------------

  //  Int_t C4Offset=108;
  Int_t C4Offset=0;
  TH1F* Chi2_4_dof[9];
  Chi2_4_dof[0]= new TH1F("Chi2_4_dofa","Chi2/DOF 3a",30,0,3);
  Chi2_4_dof[1]= new TH1F("Chi2_4_dofb","Chi2/DOF 3b",30,0,3);
  Chi2_4_dof[2]= new TH1F("Chi2_4_dofc","Chi2/DOF 3c",30,0,3);
  Chi2_4_dof[3]= new TH1F("Chi2_4_dofd","Chi2/DOF 3d",30,0,3);
  Chi2_4_dof[4]= new TH1F("Chi2_4_dofe","Chi2/DOF 3e",30,0,3);
  Chi2_4_dof[5]= new TH1F("Chi2_4_doff","Chi2/DOF 3f",30,0,3);
  Chi2_4_dof[6]= new TH1F("Chi2_4_doff","Chi2/DOF 3f",30,0,3);
  Chi2_4_dof[7]= new TH1F("Chi2_4_doff","Chi2/DOF 3f",30,0,3);
  Chi2_4_dof[8]= new TH1F("Chi2_4_doff","Chi2/DOF 3f",30,0,3);
  TF1* lfn=new TF1("lfn","[0]+[1]*x",-1,1.);
  TGraphErrors* gphi[9];
  for(int kene=0;kene<3;kene++)
    {
      Float_t ene=50+kene*20;
      for(int kpt=0;kpt<3;kpt++)
	{
	  c1->Clear();
	  c1->Divide(2,4);
	  int kknt=kpt+3*kene;
	  gphi[kknt]=new TGraphErrors();
	  char gname[100];
	  sprintf(gname,"gphi_%d_%d",kknt,kpt);
	  gphi[kknt]->SetName(gname);
	  Float_t dptbin=10/6.;
	  Float_t ptbin=dptbin+kpt*2*dptbin;
	  sprintf(cutname," energy=%5.2f  pt=%5.2f",ene,ptbin);
	  gphi[kknt]->SetTitle(gname);
	  gphi[kknt]->GetYaxis()->SetLabelSize(.03);
	  gphi[kknt]->GetYaxis()->SetTitleOffset(1.3);

	  for(int kphi=0;kphi<6;kphi++)
	    {
	      c1->cd(kphi+1);
	      Float_t phibin=(3.1415/12*(2*kphi+1));
	      
	      int iC4=kphi+6*kpt+18*kene+C4Offset;
	      //	      sprintf(cfout,"DirC4cut%dset%s_nb10_f0",iC4,(const char*) hexset);
	      sprintf(cfout,"DirC4cut%dset%s_nb10_f0",iC4,(const char*) hexset);
	      TH1F* Asm4=0;
	      sprintf(cutname," energy=%5.2f  pt=%5.2f phi=%5.2f ",ene,ptbin,phibin);
	      if(ffout->Get(cfout))
		{
		  sprintf(hname,"C4cut%d",iC4);
		  Asm4=(TH1F*) ((TDirectory*) ffout->Get(cfout))->Get("Asm");
		  printf("got Asm4\n");
		}
	      if(Asm4!=0)
		{
		  if( Asm4->GetEntries()>2)
		    {
		      printf("Asm4 ok\n");
		      Asm4->Scale(1/pol);
		      Asm4->GetYaxis()->SetTitle("AN (pol=.5)");
		      Asm4->GetYaxis()->SetLabelSize(.03);
		      Asm4->GetYaxis()->SetTitleOffset(1.3);
		      Asm4->GetYaxis()->SetRangeUser(-.1,.1);
		      if(Asm4->GetMaximum()>.1||Asm4->GetMinimum()<.1)
			{
			  Asm4->GetYaxis()->SetRangeUser(-.5,.5);
			};
		      Asm4->SetName(hname);		  
		      an=dan=0;
		      chi2=100.;
		      NDF=0;
		      if(Asm4->GetEntries()>2)
			{
			  lfn->FixParameter(0,LuminosityRatio);
			  lfn->SetParameter(1,.01);
			  Asm4->SetMarkerColor(2);
			  Asm4->Fit("lfn","","",-1.,1.);
			  if(Asm4->GetFunction("lfn"))
			    {
			      an=Asm4->GetFunction("lfn")->GetParameter(1);
			      dan=Asm4->GetFunction("lfn")->GetParError(1);
			      chi2=Asm4->GetFunction("lfn")->GetChisquare();
			      NDF=Asm4->GetFunction("lfn")->GetNDF();
			      if(NDF>0)Chi2_4_dof[kphi]->Fill(chi2/NDF);
			    }
			  else 
			    {
			      an=dan=chi2=0;
			    };
			};
		      //Asm4->SetTitle(cutname);
		      //Asm4->SetTitle(cfout);
		      Asm4->Draw();
		      Asm4->Write();
		      int gcnt;
		      
		      if(chi2<50)
			{		      
			  gcnt=gphi[kknt]->GetN();
			  gphi[kknt]->SetPoint(gcnt,cos(phibin),an);
			  gphi[kknt]->SetPointError(gcnt,0,dan);
			}
		    };
		};
	    };
	  gphi[kknt]->GetXaxis()->SetTitle("cos(delPhi)");
	  gphi[kknt]->GetYaxis()->SetTitle("AN (pol=.5)");
	  gphi[kknt]->GetYaxis()->SetTitleOffset(1.5);

	  gphi[kknt]->Write();
	  c1->cd(8);
	  gphi[kknt]->Draw("A*");
	  c1->Print(psname);
	  c1->Clear();
	  gphi[kknt]->Draw("A*");
	  c1->Print(psname);
	};
    };
  
  //---------------------
 //----------------------
  //  Int_t C5Offset=108;
  Int_t C5Offset=0;
  TH1F* Chi2_5_dof[9];
  Chi2_5_dof[0]= new TH1F("Chi2_5_dofa","Chi2/DOF 3a",30,0,3);
  Chi2_5_dof[1]= new TH1F("Chi2_5_dofb","Chi2/DOF 3b",30,0,3);
  Chi2_5_dof[2]= new TH1F("Chi2_5_dofc","Chi2/DOF 3c",30,0,3);
  Chi2_5_dof[3]= new TH1F("Chi2_5_dofd","Chi2/DOF 3d",30,0,3);
  Chi2_5_dof[4]= new TH1F("Chi2_5_dofe","Chi2/DOF 3e",30,0,3);
  Chi2_5_dof[5]= new TH1F("Chi2_5_doff","Chi2/DOF 3f",30,0,3);
  Chi2_5_dof[6]= new TH1F("Chi2_5_doff","Chi2/DOF 3f",30,0,3);
  Chi2_5_dof[7]= new TH1F("Chi2_5_doff","Chi2/DOF 3f",30,0,3);
  Chi2_5_dof[8]= new TH1F("Chi2_5_doff","Chi2/DOF 3f",30,0,3);
  
  TGraphErrors* gphi5[9];
  for(int kene=0;kene<3;kene++)
    {
      Float_t ene=50+kene*20;
      for(int kpt=0;kpt<3;kpt++)
	{
	  c1->Clear();
	  c1->Divide(2,4);
	  int kknt=kpt+3*kene;
	  gphi5[kknt]=new TGraphErrors();
	  char gname[100];
	  sprintf(gname,"gphi5_%d",kknt);
	  gphi5[kknt]->SetName(gname);
	  Float_t dptbin=10/6.;
	  Float_t ptbin=dptbin+kpt*2*dptbin;
	  sprintf(cutname," energy=%5.2f  pt=%5.2f",ene,ptbin);
	  gphi5[kknt]->SetTitle(gname);
	  gphi5[kknt]->GetYaxis()->SetLabelSize(.03);
	  gphi5[kknt]->GetYaxis()->SetTitleOffset(1.3);

	  for(int kphi=0;kphi<6;kphi++)
	    {
	      c1->cd(kphi+1);
	      Float_t phibin=(3.1415/12*(2*kphi+1));
	      sprintf(cutname," energy=%5.2f  pt=%5.2f phi=%5.2f ",ene,ptbin,phibin);
	      
	      int iC5=kphi+6*kpt+18*kene+C5Offset;
	      //	      sprintf(cfout,"DirC5cut%dset%s_nb10_f0",iC5,(const char*) hexset);
	      sprintf(cfout,"DirC5cut%dset%s_nb10_f0",iC5,(const char*) hexset);
	      TH1F*  Asm5=0;
	      cout<<"Asm5: "<<cfout<<"\n";
	      if(ffout->Get(cfout))
		{
		  sprintf(hname,"C5cut%d",iC5);
		  Asm5=(TH1F*) ((TDirectory*) ffout->Get(cfout))->Get("Asm");
		  printf("got Asm5\n");
		}
	      if(Asm5!=0)
		{
		  if( Asm5->GetEntries()>2)
		    {
		      printf("Asm5 ok\n");
		      Asm5->Scale(1/pol);
		      Asm5->GetYaxis()->SetTitle("AN (pol=.5)");
		      Asm5->GetYaxis()->SetLabelSize(.03);
		      Asm5->GetYaxis()->SetTitleOffset(1.3);
		      Asm5->GetYaxis()->SetRangeUser(-.1,.1);
		      if(Asm5->GetMaximum()>.1||Asm5->GetMinimum()<.1)
			{
			  Asm5->GetYaxis()->SetRangeUser(-.5,.5);
			};
		      Asm5->SetName(hname);		  
		      chi2=100.;
		      an=dan=0;
		      NDF=0;
		      if(Asm5->GetEntries()>2)
			{
			  lfn->FixParameter(0,LuminosityRatio);		  
			  lfn->SetParameter(1,.01);
			  Asm5->SetMarkerColor(2);
			  Asm5->Fit("lfn","","",-1.,1.);
			  if(Asm5->GetFunction("lfn"))
			    {
			      an=Asm5->GetFunction("lfn")->GetParameter(1);
			      dan=Asm5->GetFunction("lfn")->GetParError(1);
			      chi2=Asm5->GetFunction("lfn")->GetChisquare();
			      NDF=Asm5->GetFunction("lfn")->GetNDF();
			      if(NDF>0)Chi2_5_dof[kphi]->Fill(chi2/NDF);
			    }
			  else 
			    {
			      an=dan=chi2=0;
			    };
			};
		      //		      Asm5->SetTitle(cutname);
		      Asm5->Draw();
		      Asm5->Write();
		      int gcnt;
		      
		      if(chi2<50)
			{		      
			  gcnt=gphi5[kknt]->GetN();
			  gphi5[kknt]->SetPoint(gcnt,cos(phibin),an);
			  gphi5[kknt]->SetPointError(gcnt,0,dan);
			}
		    };
		};
	      
	    };
	  cout<<"exit kphi loop npts="<<gphi5[kknt]->GetN()<<"\n";

	  gphi5[kknt]->GetXaxis()->SetTitle("cos(delPhi)");
	  gphi5[kknt]->GetYaxis()->SetTitle("AN (pol=.5)");
	  gphi5[kknt]->GetYaxis()->SetTitleOffset(1.5);
	  
	    
	  gphi5[kknt]->Write();
	  c1->cd(8);
	  if(gphi5[kknt]->GetN()>0)gphi5[kknt]->Draw("A*");
	  c1->Print(psname);
	  c1->Clear();
	  if(gphi5[kknt]->GetN()>0)gphi5[kknt]->Draw("A*");
	  c1->Print(psname);
	};
    };
  cout << "done with Asm5\n";
  //--------------------

  for(float eta=2.65;eta<4.1;eta=eta+.1)
    {
      c1->Clear();
      c1->Divide(2,3);
      c1->cd(1);
      printf("eta=%f \n",eta);
      sprintf(cutname," Eta=%1.3f ",eta);
      sprintf(cfout,"DirEdcut%dset%s_nb15",etacnt+offset,(const char*) hexset);
      sprintf(hname,"Edcut%d",etacnt+offset);
      
      cout<<"dir="<<cfout<<"\n";
      etacnt++;
      
      TH1F* CrossRat=0;
      if(ffout->Get(cfout))
	{
	  CrossRat=(TH1F*) ((TDirectory*) ffout->Get(cfout))->Get("CrossRat");
	}
      else
	{
	  cout<<cfout<<"not found \n";
	};
      
      TGraphErrors gr;
      
      if(CrossRat)
	{
	  CrossRat->Scale(pcos);
	  CrossRat->GetYaxis()->SetTitle("Cross AN (<cos>=.7 pol=.5)");
	  CrossRat->GetYaxis()->SetRangeUser(-.03,.120);
	  if(CrossRat->GetBinContent(5)>.12) 
	    CrossRat->GetYaxis()->SetRangeUser(-.03,.20);
	  CrossRat->GetXaxis()->SetRangeUser(0.,95.);
	  CrossRat->SetStats(0);
	  CrossRat->GetYaxis()->SetLabelSize(.03);
	  CrossRat->GetYaxis()->SetTitleOffset(1.3);
	  CrossRat->Draw();
	  TLine line(0.,0.,95.,0.);
	  line.Draw("same");
	  TText txt(10.,.1,cutname);
	  txt->Draw("same");
	  fun->Draw("same");
	  printf("etacnt=%d \n",etacnt);
	}
      
      for(int kcnt=2;kcnt<7;kcnt+=2)
	{
	  iofs=(kcnt/2-1)*15;
	  c1->cd(kcnt);
	  sprintf(cfout,"DirCcut%dset%s_nb10_f0",etacnt+iofs-1,(const char*) hexset);
	  an=dan=0;
	  
	  cout<<cfout<<"\n";
	  if(ffout->Get(cfout) )
	    {
	      ((TDirectory*) ffout->Get(cfout))->ls();
	      char hnam2[200];
	      sprintf(hnam2,"CosPhiEtacut%dE%3.0f",etacnt+iofs,ebin[2+iofs/15]);
	      int kknt=iofs/15;
	      Float_t pt=ebin[2+iofs/15]*2*exp(-eta);
	      
	      TH1F* Asm=(TH1F*) ((TDirectory*) ffout->Get(cfout))->Get("Asm");
	      printf("hnam2=%s\n",hnam2);
	      Asm->GetYaxis()->SetLabelSize(.03);
	      Asm->GetYaxis()->SetTitleOffset(1.3);
	      Asm->SetName(hnam2);
	      
	      Asm->Scale(1./pol);
	      Asm->GetYaxis()->SetTitle("AN (pol=.5)");
	      Asm->GetXaxis()->SetTitle("Cos(phi)");
	      lfn->FixParameter(0,LuminosityRatio);		  
	      lfun->SetParameter(1,.01);
	      Asm->SetMarkerColor(2);
	      cout<<"fitting Asm\n";
	      Asm->Fit("lfun","","",-1.,1.);
	      cout<<"fit done\n";
	      gr.SetPoint(iofs/15,ebin[2+iofs/15],Asm->GetFunction("lfun")->GetParameter(1));
	      gr.SetPointError(iofs/15,0,Asm->GetFunction("lfun")->GetParError(1));
	      cout<<"gr filled\n";
	      cout<<"gr with npoints="<<gr.GetN()<<"\n";
	      Asm->GetYaxis()->SetRangeUser(-.1,.1);
	      gStyle->SetOptFit();
	      Asm->Draw();
	      Asm->Write(hnam2);
	      an=Asm->GetFunction("lfun")->GetParameter(1);
	      dan=Asm->GetFunction("lfun")->GetParError(1);
	      cout<<"an dan obtained\n";
	      gcnt=pTGr[kknt].GetN();
	      pTGr[kknt].SetPoint(gcnt,pt,an);
	      pTGr[kknt].SetPointError(gcnt,0,dan); 
	      
	      if(eta<3.5)
		{
		  gcnt=ptGr[kknt].GetN();
		  ptGr[kknt].SetPoint(gcnt,pt,an);
		  ptGr[kknt].SetPointError(gcnt,0,dan); 
		}
	      Asm->Draw();
	    };
	  c1->cd(3);
	  gr.SetMarkerColor(2);
	  gr.SetLineColor(2);
	  gr.GetYaxis()->SetTitle("AN (pol=.5)");
	  gr.GetXaxis()->SetTitle("Pt (GeV)");
	  
	  gr.Draw("A*");
	  char grname[200];
	  sprintf(grname,"gr_Cphi%5.3f",eta);
	  gr.Write(grname);
	}
      c1->Update();
      c1->Print(psname);
      c1->Write(hname);  
      c1->Clear();
    };
  /*
    ptGr Fitted An vs pt plotted with eta bins
    ptGp Fitted An vs pt plotted with pt bins DirC3
    pTGr
   */
  ptGpaff[0].SetName("gr_Cphi_0d");
  ptGpaff[1].SetName("gr_Cphi_1d");
  ptGpaff[2].SetName("gr_Cphi_2d");
  TF1* cpow=new TF1("cpow","[0]*pow(x,[1])");

  for(int kknt=0;kknt<3;kknt++)
    {
      sprintf(hname," AN from cos(phi) fit; Eta bins Plotted as Pt (E=%4.0f)",encut[kknt]);
      ptGr[kknt].SetTitle(hname);
      ptGr[kknt].GetYaxis()->SetTitle("AN (pol=.5)");
      ptGr[kknt].GetXaxis()->SetTitle("Pt (GeV)");
      pTGr[kknt].SetTitle(hname);
      pTGr[kknt].GetYaxis()->SetTitle("AN (pol=.5)");
      pTGr[kknt].GetXaxis()->SetTitle("Pt (GeV)");
      sprintf(hname," A_N from cos(phi) fit3 vs Pt (E=%4.0f)",encut[kknt]);
      sprintf(hnameY," A_N (Yellow) from cos(phi) fit vs Pt (E=%4.0f)",encut[kknt]);
      ptGp[kknt].SetTitle(hname);
      ptGp[kknt].GetYaxis()->SetTitle("AN (pol=.5)");
      ptGp[kknt].GetXaxis()->SetTitle("Pt (GeV)");
      ptGp[kknt].GetYaxis()->SetRangeUser(-.04,.08);
      if(kknt==0)ptGp[kknt].GetYaxis()->SetRangeUser(-.01,.04);

      ptGpff[kknt].SetTitle(hname);
      ptGpff[kknt].GetYaxis()->SetTitle("AN (pol=.5)");
      ptGpff[kknt].GetXaxis()->SetTitle("Pt (GeV)");
      ptGpff[kknt].GetYaxis()->SetRangeUser(-.04,.08);
      if(kknt==0)ptGpff[kknt].GetYaxis()->SetRangeUser(-.01,.04);
      ptGpaff[kknt].SetTitle(hname);
      ptGpaff[kknt].GetYaxis()->SetTitle("AN (pol=.5)");
      ptGpaff[kknt].GetXaxis()->SetTitle("Pt (GeV)");
      ptGpaff[kknt].GetYaxis()->SetRangeUser(-.04,.08);
      if(kknt==0)ptGpff[kknt].GetYaxis()->SetRangeUser(-.01,.04);

      ptGpffY[kknt].SetTitle(hnameY);
      ptGpffY[kknt].GetYaxis()->SetTitle("AN (pol=.5)");
      ptGpffY[kknt].GetXaxis()->SetTitle("Pt (GeV)");
      ptGpffY[kknt].GetYaxis()->SetRangeUser(-.04,.08);
      if(kknt==0)ptGpffY[kknt].GetYaxis()->SetRangeUser(-.01,.04);




      ptGr[kknt].Draw("A*");
      TLine line(0.,0.,14.,0.);
      line.Draw("same");

      ptGr[kknt].Fit("pol1","","",1.5,10.);
      c1->Print(psname);
      c1->Clear();
      pTGr[kknt].Draw("A*");
      line.Draw("same");

      pTGr[kknt].Fit("pol1","","",1.5,10.);
      printf("xxx\n");
      c1->Print(psname);
      ptGp[kknt].Draw("A*");
      line.Draw("same");
      c1->Print(psname);
      ptGpff[kknt].Draw("A*");
      line.Draw("same");
      c1->Print(psname);

      ptGpffY[kknt].Draw("A*");
      line.Draw("same");
      c1->Print(psname);

      ptGpaff[kknt].Fit("cpow","","",lowpt[kknt],hipt[kknt]);
      gStyle->SetOptFit();
      TList* fflist=ptGpaff[kknt].GetListOfFunctions();
      TPaveStats* stats=0;
      if(fflist)stats=(TPaveStats*) fflist->FindObject("stats");
      if(stats)
	{
	  stats->SetFillColor(408);
	  stats->SetTextFont(72);
	  stats->SetTextSize(0.035);
	}
      else
	{
	  cout<<"No Stats Found\n";
	};
      ptGpaff[kknt].GetYaxis()->SetTitleOffset(1.7);
      ptGpaff[kknt].SetMarkerStyle(20);
      ptGpaff[kknt].SetMarkerColor(435);
      ptGpaff[kknt].SetLineColor(4);
      ptGpaff[kknt].Draw("A*");
      cout<<"ff draw done\n";
      c1->GetFrame()->SetFillColor(424);
      c1->GetFrame()->SetBorderSize(4);
      c1->GetFrame()->SetBorderMode(1);
      c1->SetLeftMargin(.15);


      TString c1name("c1");
      cout<<"z1z1: "<<ptGpaff[kknt].GetName()<<"\n";;
      c1name=c1name+TString(ptGpaff[kknt].GetName());
      cout<<c1name<<"\n";
      c1->Write(c1name);
      c1->Print(psname);
    };

  c1->Print(psname+TString(")"));
  printf("Write many\n");
  ptGr[0].Write("gr_Cphi_0");
  printf("W\n");
  ptGr[1].Write("gr_Cphi_1");
  printf("W\n");
  ptGr[2].Write("gr_Cphi_2");
  printf("W\n");
  pTGr[0].Write("gr_Cphi_0a");
  printf("W\n");
  pTGr[1].Write("gr_Cphi_1a");
  printf("W\n");
  pTGr[2].Write("gr_Cphi_2a");
  printf("W\n");
  ptGp[0].Write("gr_Cphi_0b");
  printf("W\n");
  ptGp[1].Write("gr_Cphi_1b");
  printf("W\n");
  ptGp[2].Write("gr_Cphi_2b");
  printf("W end\n");
  ptGpff[0].Write("gr_Cphi_0c");
  printf("W\n");
  ptGpff[1].Write("gr_Cphi_1c");
  printf("W\n");
  ptGpff[2].Write("gr_Cphi_2c");
  printf("W end\n");

  ptGpffY[0].Write("gr_Cphi_0Y");
  printf("W end\n");
  ptGpffY[1].Write("gr_Cphi_1Y");
  printf("W end\n");
  ptGpffY[2].Write("gr_Cphi_2Y");
  printf("W end\n");

  ptGpaff[0].Write("gr_Cphi_0d");
  printf("W\n");
  ptGpaff[1].Write("gr_Cphi_1d");
  printf("W\n");
  ptGpaff[2].Write("gr_Cphi_2d");
  printf("W end\n");


  char cmd[200];
  sprintf(cmd,"ps2pdf %s ; rm %s ",(const char*) psname, (const char*) psname);
  cout<<cmd<<"\n";
  system(cmd);
}
