{
  // the following code sets up p_files to point to all the needed text files
  //

  gStyle->SetPalette();
  TString str=gSystem->ExpandPathName("$SETFMSENV");
  if(str!="SETFMSENV"){printf("source SetFMSEnv first");exit();};
  gROOT->Reset();
  gStyle->SetPalette(1);
  TString FMSTXT =gSystem->ExpandPathName("${FMSTXT}");
  FMSTXT=FMSTXT+"/";
  TString FMSGAIN =gSystem->ExpandPathName("${FMSGAIN}");
  TString FMSCORR =gSystem->ExpandPathName("${FMSCORR}");
  TString QTMAP = gSystem->ExpandPathName("${QTMAP}");
  TString QTMAP2PP = gSystem->ExpandPathName("${QTMAP2PP}");
  gSystem->Load("${FMSSRC}/Fpdchan.so");
  TString FMSTXT=gSystem->ExpandPathName("${FMSTXT}");
  cout<<"FMSTXT=" <<FMSTXT <<"\n";

  FilesSet*  p_files=new FilesSet(  (char*) FMSTXT,
                                    "fpdped.txt",
                                    (char*) FMSGAIN,
                                    (char*) FMSCORR,
                                    "fill.txt",
                                    "Fake",
                                    "spinpat",
                                    "geom.txt",
                                    (char*) QTMAP,
                                    (char*) QTMAP2PP);

  Int_t firstrun=12079000;
  Int_t lastrun=12099000;
  Fill* RFill=new Fill(p_files,14000,16000,firstrun,lastrun);
  RFill->ListFills();
  printf("ok\n");
  RFill->SetFillNumberforRun(12095006);
  RFill->Print();
  TIter next(RFill->pFillArray);
  FillData* fd;
  Int_t nunique=0;
  Int_t Match=-1;
  TVectorT<float>*  unique[1000][2];
  while(fd=(FillData*) next())
    {
      RFill->SetFillNumber(fd->FillNumber);
      Match=-1;
      Float_t s1,s2,s3,s4;
      s2=RFill->Dot((RFill->BlueVec()),(RFill->BlueVec()));	  
      s4=RFill->Dot((RFill->YellowVec()),(RFill->YellowVec()));
      for(int j=0;j<nunique;j++)
	{
	  if(Match==-1)
	    {
	      //	      printf("fill%d j=%d\n",fd->FillNumber,j);
	      s1=RFill->Dot(*(unique[j][0]),(RFill->BlueVec()));
	      
	      s3=RFill->Dot(*(unique[j][1]),(RFill->YellowVec()));
	      
	      Bool_t bluematch=(s1==s2);
	      
	      Bool_t yellowmatch=(s3==s4);
	      //	      printf("s1=%f s2=%f s3=%f s4=%f \n",s1,s2,s3,s4);
	      if(s1==s2 && s3==s4)
		{
		  //		  printf("match found with %d \n",j);
		  Match=j;
		}
	    };
	};
      if(Match==-1)
	{
	  unique[nunique][0]=new TVectorT<float>(RFill->BlueVec());
	  unique[nunique][1]=new TVectorT<float>(RFill->YellowVec());
	  nunique++;
	  //	  printf("add to list\n");
	  Match=nunique;
	}
      printf("Set = %d \n",Match);
      RFill->Print();
    };
  
  TChain TwoTr("TwoTr");
  TwoTr->Add("../OutputN/O*.root");

//Declaration of leaves types
   Float_t         M12;
   Float_t         MC12;
   Float_t         N12;
   Int_t           Nclust;
   Float_t         EC12;
   Float_t         E12;
   Float_t         C12;
   Float_t         Y1;
   Float_t         Y2;
   Float_t         Phi1;
   Float_t         Phi2;
   Float_t         Phi;
   Float_t         Z;
   Float_t         Eta;
   Float_t         Pt;
   Float_t         Phicm;
   Float_t         Ntracks;
   Float_t         det12;
   Int_t           edge;
   Float_t         Esoft;
   Float_t         NMass;
   Float_t         NE;
   Float_t         NY;
   Float_t         NPhicm;
   Float_t         NPhi;
   Float_t         NPt;
   Float_t         Maway;
   Float_t         Phiaway;
   Float_t         Yaway;
   Float_t         NPtaway;
   Int_t           spin;
   UChar_t         BBcSums[5];
   Float_t         BBcVertex;
   Float_t         Edet[4];
   Int_t           TrigBits;
   Int_t           Bunchid7bit;
   Int_t           Rnum;
   Float_t         dthx;
   Float_t         dthy;
   Float_t         sigmaMaxF1;
   Float_t         chiSquareF1;
   Float_t         chiSquareF2;

   // Set branch addresses.
   TwoTr->SetBranchAddress("M12",&M12);
   TwoTr->SetBranchAddress("MC12",&MC12);
   TwoTr->SetBranchAddress("N12",&N12);
   TwoTr->SetBranchAddress("Nclust",&Nclust);
   TwoTr->SetBranchAddress("EC12",&EC12);
   TwoTr->SetBranchAddress("E12",&E12);
   TwoTr->SetBranchAddress("C12",&C12);
   TwoTr->SetBranchAddress("Y1",&Y1);
   TwoTr->SetBranchAddress("Y2",&Y2);
   TwoTr->SetBranchAddress("Phi1",&Phi1);
   TwoTr->SetBranchAddress("Phi2",&Phi2);
   TwoTr->SetBranchAddress("Phi",&Phi);
   TwoTr->SetBranchAddress("Z",&Z);
   TwoTr->SetBranchAddress("Eta",&Eta);
   TwoTr->SetBranchAddress("Pt",&Pt);
   TwoTr->SetBranchAddress("Phicm",&Phicm);
   TwoTr->SetBranchAddress("Ntracks",&Ntracks);
   TwoTr->SetBranchAddress("det12",&det12);
   TwoTr->SetBranchAddress("edge",&edge);
   TwoTr->SetBranchAddress("Esoft",&Esoft);
   TwoTr->SetBranchAddress("NMass",&NMass);
   TwoTr->SetBranchAddress("NE",&NE);
   TwoTr->SetBranchAddress("NY",&NY);
   TwoTr->SetBranchAddress("NPhicm",&NPhicm);
   TwoTr->SetBranchAddress("NPhi",&NPhi);
   TwoTr->SetBranchAddress("NPt",&NPt);
   TwoTr->SetBranchAddress("Maway",&Maway);
   TwoTr->SetBranchAddress("Phiaway",&Phiaway);
   TwoTr->SetBranchAddress("Yaway",&Yaway);
   TwoTr->SetBranchAddress("Ptaway",&NPtaway);
   TwoTr->SetBranchAddress("spin",&spin);
   TwoTr->SetBranchAddress("BBcSums",BBcSums);
   TwoTr->SetBranchAddress("BBcVertex",&BBcVertex);
   TwoTr->SetBranchAddress("EDet",Edet);
   TwoTr->SetBranchAddress("TrigBits",&TrigBits);
   TwoTr->SetBranchAddress("Bunchid7bit",&Bunchid7bit);
   TwoTr->SetBranchAddress("Rnum",&Rnum);
   TwoTr->SetBranchAddress("dthx",&dthx);
   TwoTr->SetBranchAddress("dthy",&dthy);
   TwoTr->SetBranchAddress("sigmaMaxF1",&sigmaMaxF1);
   TwoTr->SetBranchAddress("chiSquareF1",&chiSquareF1);
   TwoTr->SetBranchAddress("chiSquareF2",&chiSquareF2);

   TFile fout("fout20.root","recreate");
   TTree TwoFr("TwoFr","TwoFr");
   TwoFr->Branch("M12",&M12,"M12/F");
   TwoFr->Branch("N12",&N12,"N12/F");
   TwoFr->Branch("E12",&E12,"E12/F");
   TwoFr->Branch("Eta",&Eta,"Eta/F");
   TwoFr->Branch("Phi",&Phi,"Phi/F");
   TwoFr->Branch("spin",&spin,"spin/I");
   TwoFr->Branch("Bunchid7bit",&Bunchid7bit,"Bunchid7bit/I");
   TwoFr->Branch("Rnum",&Rnum,"Rnum/I");
   
   Long64_t nentries= TwoTr->GetEntries();
   Long64_t nbytes=0;
   Int_t lastfill=0;
   Int_t lastrun=0;
   Int_t LastSet=-1;
   Float_t z1,z2,z3,z4;
   TwoFr->Branch("Set",&LastSet,"Set/I");
   TwoFr->Branch("Fill",&lastfill,"Fill/I");

   printf("nentries=%d\n",nentries);

   for( Long64_t i=0;i<nentries;i++)
     {
       nbytes += TwoTr->GetEntry(i);
       if(Rnum!=lastrun)
	 {
	   RFill->SetFillNumberforRun(Rnum);
	   lastfill=RFill->GetFillNumber();
	   lastrun=Rnum;
	   for(int j=0;j<nunique;j++)
	     {
	       z1=RFill->Dot(*(unique[j][0]),(RFill->BlueVec()));
	       z2=RFill->Dot(*(unique[j][1]),(RFill->YellowVec()));
	       z3=RFill->Dot((RFill->BlueVec()),(RFill->BlueVec()));
	       z4=RFill->Dot((RFill->YellowVec()),(RFill->YellowVec()));
	       if(z1==z3 && z2==z4)
		 {
		   LastSet=j;
		   printf("RunNum=%d Set=%d \n",Rnum,LastSet);
		   cout<< " Entries so far= "<< TwoFr->GetEntries()<<"\n";
		 };
	     };
	 };
       //       cout<< N12 << " " <<  cos(Phi) << " " << Eta<< "\n";
       if((N12==1 || N12==2) && fabs(cos(Phi))>.5 && fabs(Eta-3.65)<.4 )
	 {
	   //	   cout<<"pass \n";
	   TwoFr->Fill();
	 };
     };
   TwoFr->Write();
}
