{
  gROOT->Reset();
  gROOT->Macro("start.C");
  TChain* TwoTr=new TChain("TwoTr");
  //  TwoTr->Add("../Output/Outputset*");
  TwoTr->Add("../Output/Outputset*");
  TH3F* small=new TH3F("small","small",52,-26,26,52,-26,26,50,0,2.);
  TH3F* large=new TH3F("large","large",34,-17,17,34,-17,17,50,0,2.);
  Int_t HiTow=(0x03);
  Int_t JetPatch=((0x07)<<8);
  Int_t Fpd=(0x01)<<14;
  Int_t clbit=((0x03F)<<2);
 
  TwoTr->Project("small","M12:730/3.8*sin(Phi1)*2*exp(-Y1):730/3.8*cos(Phi1)*2*exp(-Y1)","N12==2&&abs(E12-110)<15&&Esoft<1&&Z<.85&&((TrigBits>>8)&7)>0");
  TwoTr->Project("large","M12:730/3.8*sin(Phi1)*2*exp(-Y1):730/3.8*cos(Phi1)*2*exp(-Y1)","N12==2&&abs(E12-75)<20&&Esoft<1&&Z<.7");
  TCanvas* c1=new TCanvas("c1","c1",500,1000);
  c1->Divide(1,2);
  c1->cd(1);
  small->Draw("box");
  c1->cd(2);
  large->Draw("box");
  c1->Print("CellStudy3D.ps(");
  char cut[300];
  gStyle->SetOptFit();
  gStyle->SetPalette(1);
  TH2F* Small=new TH2F("Small","Small",24,-12,12,24,-12,12);
  Small->SetMinimum(.05);
  Small->SetMaximum(.75);

  for(int j=-12;j<12;j++)
    {
      for(int k=-12;k<12;k++)
	{
	  c1->cd(1);
	  char nam[300];
	  sprintf(nam,"bin%d_%d",j,k);
	  TH1D* h1=new TH1D(*(small->ProjectionZ(nam,27+j,27+j,27+k,27+k)));
	  //	  h1->Fit("gaus","l","",.08,.18);
	  h1->Fit("gaus","l","",.3,.75);
	  if(h1->Integral(1,10)>10)
	    {
	      Float_t mval=h1->GetFunction("gaus")->GetParameter(1);
	      Float_t merr=h1->GetFunction("gaus")->GetParError(1);
	      Float_t x,y;
	      int bin=Small->FindBin(x=.5+j,y=.5+k);
	      printf("x=%f y=%f bin=%d mval=%f\n",x,y,bin,mval);
	      Small->SetBinContent(bin,mval);
	      Small->SetBinError(bin,merr);
	      c1->cd(2);
	      Small->Draw("zcol");
	      
	      c1->Print("CellStudy3D.ps");
	      c1->Update();
	    };
	}
    };
  c1->Print("CellStudy3D.ps)");
  system("ps2pdf CellStudy3D.ps;rm CellStudy3D.ps");
}
