{
  gROOT->Reset();
  gROOT->Macro("start.C");
  RunDepMgr* Mgr=new RunDepMgr("",12095005);

  Geom* p_geom=new Geom(p_files);
  TChain* TwoTr=new TChain("TwoTr");
  //  TwoTr->Add("../Output/Outputset08[6-9]*");
  //  TwoTr->Add("../Output/Outputset08[7-9]*");
  //  TwoTr->Add("../OutputA/Outputset09*");
  TwoTr->Add("../Output/Outputset0[7-9]*");

  TH3F* small=new TH3F("small","small",24,-12,12,24,-12,12,50,0,1.);


  TH3F* smalle=new TH3F("smalle","smalle",52,-26,26,52,-26,26,50,0,100.);
  TH3F* large=new TH3F("large","large",34,-17,17,34,-17,17,50,0,1.);
  Int_t HiTow=(0x03);
  Int_t JetPatch=((0x07)<<8);
  Int_t Fpd=(0x01)<<14;
  Int_t clbit=((0x03F)<<2);
  Float_t wx=(p_geom->FpdTowWid(2,1))[0];
  Float_t wy=(p_geom->FpdTowWid(2,1))[1];
  Float_t zz=*(p_geom->ZFPD(2,1));
  char svar[300];
  char cvar[300];
  sprintf(svar,"M12:(%f)/(%f)*sin(Phi1)*2*exp(-Y1):(%f)/(%f)*cos(Phi1)*2*exp(-Y1)",zz,wy,zz,wx);
  sprintf(cvar, "Ntracks==2&&N12==2&&abs(E12-25)<10&&Esoft<1&&Z<.8&&((TrigBits)&(3<<8))==256&&sqrt(pow(Y2-Y1,2)+pow(Phi2-Phi1,2))<.2");

  printf("%s\n%s\n",svar,cvar);
  TwoTr->Project("large",svar,cvar);
  printf("project large done\n");

  TCanvas* c1=new TCanvas("c1","c1",600,700);
  c1->Divide(2,2);
  c1->cd(1);
  //small->Draw("box");
  c1->cd(2);
  large->Draw("box");
  c1->Print("CellStudy3Db.ps(");
  char cut[300];
  gStyle->SetOptFit();
  gStyle->SetPalette(1);
  TH2F* Large=new TH2F("Large","Large",34,-17,17,34,-17,17);
  Float_t lowlim,hilim;

  Large->SetMinimum(.08);
  Large->SetMaximum(.16);
  Large->SetStats(0);
  int newcnt=0;
  TH2F* hh=0;
  for(int j=-17;j<17;j++)
    {
      for(int k=-17;k<+17;k++)
	{
	  newcnt++;
	  c1->Clear();
	  c1->Divide(2,2);
	  c1->cd(3);
	  char str[200];
	  char snam[200];
	  int Nstb0=1;
	  int ro=-j+16;
	  int co=k;
	  if(k<0)
	    {Nstb0=0;co=-(k+1);};
	  TVector3 vec( (.5+k)*wx,(.5+j)*wy,0);
	  TVector3 lvec=p_geom->LocalXYZ(2,Nstb0+1,vec,true);
	  ro=lvec.Y();
	  co=lvec.X();
	  sprintf(snam,"pro_%d_d%d_r%d_c%d",newcnt,Nstb0,ro,co);

	  if(Mgr->Legal(2,Nstb0+1,ro,co))
	    {
	      
	      TString STR=cvar;
	      sprintf(str,"abs((%f)/(%f)*sin(Phi1)*2*exp(-Y1)-.5-(%d))<1.5&&abs((%f)/(%f)*cos(Phi1)*2*exp(-Y1)-.5-(%d))<1.5 ",zz,wy,j,zz,wx,k);
	      STR=STR+"&&"+str;
	      hh=new TH2F(snam,"M12vsRun",20,79.,99.,100,.0,.25);
	      hh->GetXaxis()->SetTitle("Day");
	      hh->GetYaxis()->SetTitle("Mass (GeV)");
	      hh->Draw("box");
	      c1->cd(4);
	      printf("str=%s %s\n",(const char*) STR,hh->GetName());
	      TwoTr->Project(snam,"M12:(Rnum-12000000)/1000.",STR);
	      int nentries=hh->GetEntries()+1;
	      Float_t errmin=.02/sqrt(nentries);
	      TH1D* hpro=(TH1D*) hh->ProfileX();
	      TGraphErrors ggr  ;
	      Int_t gcnt=0;
	      for(int jj=1;jj<hpro->GetNbinsX();jj++)
		{
		  
		  if(hpro->GetBinContent(jj)>0)
		    {
		      if(hpro->GetBinError(jj)<errmin)hpro->SetBinError(jj,errmin);
		      Double_t x1=hpro->GetBinCenter(jj);
		      Double_t y1=hpro->GetBinContent(jj);
		      Double_t er1=hpro->GetBinError(jj);
		      ggr.SetPoint(gcnt,x1,y1);
		      ggr.SetPointError(gcnt,0,er1);
		      gcnt++;
		      
		    }
		}
	      cout<<"name="<<hpro->GetName()<<"\n";
	      ggr.GetYaxis()->SetRangeUser(.1,.2);
	      ggr.Fit("pol1","","",79,98);
	      ggr.Draw("A*");
	      //	  htemp->ProfileX(snam)->Draw();
	      //	  hh->Draw("box");
	      //	  hh.ProfileX()->Draw();
	      printf("htemp done\n");
	      Mgr->Addmvsday(Nstb0+1,ro,co,&ggr);
	      c1->cd(4);
	      char nam[300];
	      sprintf(nam,"binEn%d_%d",j,k);
	      //	  smalle->ProjectionZ(nam,27+j,27+j,27+k,27+k)->Draw();
	      c1->cd(2);
	      sprintf(nam,"bin%d_%d",j,k);
	      TH1D* h1=new TH1D(*(large->ProjectionZ(nam,17+k,19+k,17+j,19+j)));
	      lowlim=.08;
	      hilim=.175;
	      h1->Fit("gaus","l","",lowlim,hilim);
	      //	  h1->Fit("gaus","l","",.3,.75);
	      if(h1->Integral(1,10)>5)
		{
		  Float_t mval=h1->GetFunction("gaus")->GetParameter(1);
		  Float_t merr=h1->GetFunction("gaus")->GetParError(1);
		  Float_t x,y;
		  Float_t hval=mval;
		  if(hval>hilim)hilim=hilim+.05;
		  if(hval<.16)hilim=.17;
		  if(hval<lowlim)lowlim=lowlim-.03;
		  if(fabs(hilim-lowlim-.08)>.001)
		    {
		      h1->Fit("gaus","l","",lowlim,hilim);
		      mval=h1->GetFunction("gaus")->GetParameter(1);
		      merr=h1->GetFunction("gaus")->GetParError(1);
		    };
		  
		  int bin=Large->FindBin(x=.5+k,y=.5+j);
		  printf("x=%f y=%f bin=%d mval=%f\n",x,y,bin,mval);
		  Large->SetBinContent(bin,mval);
		  Large->SetBinError(bin,merr);
		  c1->cd(1);
		  Large->Draw("zcol");
		  c1->Update();
		  c1->Print("CellStudy3Db.ps");
		};
	    };
	};
    };
  c1->Print("CellStudy3Db.ps)");
  system("ps2pdf CellStudy3Db.ps;rm CellStudy3Db.ps");
  TFile RunDep("$RunDepPath","update");
  //  Mgr->Write("Mgr");
  RunDep->Purge();
}
