{
  gROOT->Macro("start.C");
  Int_t nbins=120;
  char dirname[200];
  Long_t pathmask=0x7FFF;
  //  pathmask=0x1C0;
  pathmask=0x8;
  TString PathMask=gSystem->Getenv("PathMask");
  if(PathMask!="")
    {
      sscanf((const char*) PathMask,"%lx",&pathmask);
    };
  Int_t cutnumber=0;
  TString CutNum=gSystem->Getenv("Cut");
  Int_t nn;
  if(CutNum!="")
    {
      sscanf((const char*) CutNum,"%d",&nn);
      cutnumber=nn;
    };
  sprintf(dirname,"DirBcut%dset%lx_nb%d",cutnumber,pathmask,nbins);
  printf("%s \n",dirname);
  gROOT->Macro("CommonSpin.C");
  TH1F* BuN=new TH1F("BuN","uN",nbins,0,120.);
  TH1F* BdN=new TH1F("BdN","dN",nbins,0,120.);
  TH1F* BuS=new TH1F("BuS","uS",nbins,0,120.);
  TH1F* BdS=new TH1F("BdS","dS",nbins,0,120.);
  TString cuts0="abs(Eta-3.65)<.4&& N12==1";
  TString cuts1="abs(Eta-3.65)<.4&& N12==1 &&E12>100";
  TString cuts2="abs(Eta-3.65)<.4&& N12==1 &&E12>150";
  TString cuts3="abs(Eta-3.65)<.4&& N12==1 &&E12>200";
  TString cuts4="abs(Eta-3.75)<.2&& N12==2 && abs(M12-.55)<.25&&Z<.7&&acos(C12)<.05"; 
  TString cuts5="abs(Eta-3.75)<.2&& N12==2 && abs(M12-.55)<.25&&Z<.7&&acos(C12)<.05&&E12>120"; 

  TString cuts6="abs(Eta-3.65)<.4&& N12==2 &&abs(M12-.17)<.1";
  TString cuts7="abs(Eta-3.65)<.4&& N12==2 &&abs(M12-.17)<.1&&E12>100";
  TString cuts8="abs(Eta-3.65)<.4&& N12==2 &&abs(M12-.17)<.1&&E12>150";
  TString cuts9="abs(Eta-3.65)<.5&&N12==2 &&Z<.7&&Ntracks==2&&abs(M12-1.7)<.8";
  TString cuts10="abs(Eta-3.65)<.5&&N12==2 &&Z<.7&&Ntracks==2&&abs(M12-1.7)<.8 && E12>150";
  TString cuts11;
  TString cuts12="abs(Eta-3.65)<.2&&N12==2 &&Z<.7 &&abs(M12-.55)<.15";
  TString cuts13=  "abs(M12-.55)<.2&&N12==2&&Ntracks==2&&Esoft<.1&&abs(Eta-3.75)<.3&&edge==0&&acos(C12)<.025";
  TString cuts14= "abs(Eta-2.8)<.25&& N12==1";
  TString cuts15="abs(Eta-3.65)<.4&& N12==2 &&Ntracks==2&& abs(M12-1.6)<.9"; 
  TString cuts16="abs(Eta-3.65)<.4&&N12==2 &&Ntracks==2&&abs(M12-3.0)<.3";  
  TString cutlist[20];
  cutlist[0]=cuts0;
  cutlist[1]=cuts1;
  cutlist[2]=cuts2;
  cutlist[3]=cuts3;
  cutlist[4]=cuts4;
  cutlist[5]=cuts5;
  cutlist[6]=cuts6;
  cutlist[7]=cuts7;
  cutlist[8]=cuts8;
  cutlist[9]=cuts9;
  cutlist[10]=cuts10;
  cutlist[11]=cuts11;
  cutlist[12]=cuts12;
  cutlist[13]=cuts13;
  cutlist[14]=cuts14;
  cutlist[15]=cuts15;  
  cutlist[16]=cuts16;
  TString cuts=cutlist[cutnumber]+"&&"+TrigCut+ "&&abs(spin-1.5)<1.9 && abs(cos(Phi))>.5";
  // TString cuts=cutlist[cutnumber]+"&&"+TrigCut+"&&abs(spin-1.5)<1.9";

  TString North="&&cos(Phi)<-.5";
  TString South="&&cos(Phi)>.5";
  TString Bdown="&&abs(spin-.5)<.6";
  TString Bup="&&abs(spin-2.5)<.6";
  TString Ydown="&&spin<4&&(spin%2==0)";
  TString Yup="&&spin<4&&(spin%2==1)";
  //note the reversal of spin signs from CDev files??
  TString dn=Bup;
  TString up=Bdown;
  if(useyellow)
    {
      dn=Yup;
      up=Ydown;
    }

  TH3F* BvsdR=new TH3F("BvsdR","BvsdR",2000,79,99,120,0,120,8,0,8);

TwoTr->Project("BvsdR","spin&3:Bunchid7bit:((int(Rnum-12000000)/1000)+(Rnum%1000)/150.)",cuts);

  TH2F* NSsp=new TH2F("NSsp","NSsp",nbins,0,120,8,0,8);
  TwoTr->Project("NSsp","((cos(Phi)<0)*(spin&3))+((cos(Phi)>0)*((spin&3)+4)):Bunchid7bit",cuts);
  TwoTr->Project("BuN","Bunchid7bit",cuts+North+up);
  BuN->SetLineColor(1);
  TwoTr->Project("BdN","Bunchid7bit",cuts+North+dn);
  BdN->SetLineColor(2);
  BuN->Draw("e");
  BdN->Draw("esame");
  BuN->Sumw2();  
  BdN->Sumw2();

  TH1F* RN=new TH1F((*BuN)/(*BdN));

  TwoTr->Project("BuS","Bunchid7bit",cuts+South+up);
  BuS->SetLineColor(3);
  TwoTr->Project("BdS","Bunchid7bit",cuts+South+dn);
  BdS->SetLineColor(4);
  BuS->Draw("esame");
  BdS->Draw("esame");
  BuS->Sumw2();
  BdS->Sumw2();
  TH1F* BS=new TH1F((*BdS)+(*BuS));
  TH1F* BN=new TH1F((*BdN)+(*BuN));
  TH1F* B=new TH1F((*BN)+(*BS));
  BS->SetName("BS");
  BN->SetName("BN");
  B->SetName("B");
  c1->SetTitle("UpN=blk  UpS=grn DnN=red DnS=blue");
  c2->cd();
  c2->SetTitle("U/D_N=blk  U/D_S=blue");
  TH1F* RS=new TH1F((*BuS)/(*BdS));
  RN->Draw("e");
  RS->SetLineColor(4);
  RS->Draw("esame");
  TH1F* crossR=new TH1F(at.GetCross(BuS,BdS,BuN,BdN,"CrossRat"));
  TCanvas* c3=new TCanvas("c3","c3",800,600);
  TString ctit="Cross Ratio: ";
  ctit=ctit+cuts;
  crossR->SetTitle(ctit);
  crossR->GetXaxis()->SetTitle("B (GeV)");
  crossR->GetYaxis()->SetTitle("raw cross An");
  crossR->Draw();

  c1->Write();
  c2->Write();
  c3->Write();
  crossR->Write();
  RN->Write();
  RS->Write();
  BuS->Write();
  BdS->Write();
  BdN->Write();
  BuN->Write();
  BS->Write();
  BN->Write();
  B->Write();
  NSsp->Write();
  BvsdR->Write();
  fout.cd("../");
  
  /* usage example
TFile fout("fout.root");
TH1F* h=(TH1F*) ((TDirectory*)fout.Get("DirEcut1set7nb20"))->Get("CrossRat");h->Draw()
  */

}
