{
  gROOT->Macro("start.C");
  Int_t nbins=20;
  char dirname[200];
  Long_t pathmask=0x7FFF;
  //  pathmask=0x1C0;
  pathmask=0x8;
  TString PathMask=gSystem->Getenv("PathMask");
  if(PathMask!="")
    {
      sscanf((const char*) PathMask,"%lx",&pathmask);
    };
  Int_t cutnumber=0;
  TString CutNum=gSystem->Getenv("Cut");
  Int_t nn;
  if(CutNum!="")
    {
      sscanf((const char*) CutNum,"%d",&nn);
      cutnumber=nn;
    };
  sprintf(dirname,"DirEcut%dset%lx_nb%d",cutnumber,pathmask,nbins);
  printf("%s \n",dirname);
  gROOT->Macro("CommonSpin.C");
  TH1F* E12uN=new TH1F("E12uN","uN",nbins,0,350.);
  TH1F* E12dN=new TH1F("E12dN","dN",nbins,0,350.);
  TH1F* E12uS=new TH1F("E12uS","uS",nbins,0,350.);
  TH1F* E12dS=new TH1F("E12dS","dS",nbins,0,350.);
  TString cuts0="abs(Eta-3.65)<.4&& N12==1";
  TString cuts1="abs(Eta-3.3)<.7&& N12==2 && abs(M12-.17)<.1";
  TString cuts2="abs(Eta-3.05)<.1&& N12==1 && cos(Phi-Phiaway)<.5";
  TString cuts3="abs(Eta-3.75)<.2&& N12==2 && abs(M12-.55)<.25&&Z<.7&&acos(C12)<.05"; 

  TString cuts4="abs(Eta-3.65)<.4&& N12>2";
  TString cuts5="abs(Eta-3.25)<.2&&N12>2";
  TString cuts6="abs(Eta-3.65)<.4&& N12==2 &&abs(M12-.17)<.1"; 
  TString cuts7="abs(Eta-3.25)<.2&&N12==2 &&(M12-.135)<.12";
  TString cuts8="abs(Eta-3.65)<.2&&N12==2 &&(M12-.135)<.12";

  TString cuts9="abs(Eta-3.25)<.2&&N12==2 &&(M12-1.7)<.8";
  TString cuts10="abs(Eta-3.65)<.2&&N12==2 &&(M12-1.7)<.8";

  TString cuts11="abs(Eta-4.)<.15&&N12==2 &&abs(M12-.135)<.12";

  TString cuts12="abs(Eta-3.65)<.2&&N12==2  &&abs(M12-.55)<.12";
  TString cuts13="abs(Eta-3.25)<.2&&N12==2  &&abs(M12-.55)<.12";
  TString cuts14= "abs(Eta-2.8)<.25&& N12==1";
  TString cuts15="abs(Eta-3.65)<.4&& N12==2 &&Ntracks==2&& abs(M12-1.6)<.9"; 
  TString cuts16="abs(Eta-3.65)<.4&&N12==2 &&Ntracks==2&&abs(M12-3.0)<.3";  
  TString cutlist[20];
  cutlist[0]=cuts0;
  cutlist[1]=cuts1;
  cutlist[2]=cuts2;
  cutlist[3]=cuts3;
  cutlist[4]=cuts4;
  cutlist[5]=cuts5;
  cutlist[6]=cuts6;
  cutlist[7]=cuts7;
  cutlist[8]=cuts8;
  cutlist[9]=cuts9;
  cutlist[10]=cuts10;
  cutlist[11]=cuts11;
  cutlist[12]=cuts12;
  cutlist[13]=cuts13;
  cutlist[14]=cuts14;
  cutlist[15]=cuts15;  
  cutlist[16]=cuts16;
  TString cuts=cutlist[cutnumber]+"&&"+TrigCut+ "&&abs(spin-1.5)<1.9 && abs(cos(Phi))>.5";
  // TString cuts=cutlist[cutnumber]+"&&"+TrigCut+"&&abs(spin-1.5)<1.9";

  TString North="&&cos(Phi)<-.5";
  TString South="&&cos(Phi)>.5";
  TString Bdown="&&abs(spin-.5)<.6";
  TString Bup="&&abs(spin-2.5)<.6";
  TString Ydown="&&spin<4&&(spin%2==0)";
  TString Yup="&&spin<4&&(spin%2==1)";
  //note the reversal of spin signs from CDev files??
  TString dn=Bup;
  TString up=Bdown;
  if(useyellow)
    {
      dn=Yup;
      up=Ydown;
    }
  TH2F* NSsp=new TH2F("NSsp","NSsp",nbins,0,350,8,0,8);
  TwoTr->Project("NSsp","((cos(Phi)<0)*(spin&3))+((cos(Phi)>0)*((spin&3)+4)):E12",cuts);
  TwoTr->Project("E12uN","E12",cuts+North+up);
  E12uN->SetLineColor(1);
  TwoTr->Project("E12dN","E12",cuts+North+dn);
  E12dN->SetLineColor(2);
  E12uN->Draw("e");
  E12dN->Draw("esame");
  E12uN->Sumw2();  
  E12dN->Sumw2();

  TH1F* RN=new TH1F((*E12uN)/(*E12dN));

  TwoTr->Project("E12uS","E12",cuts+South+up);
  E12uS->SetLineColor(3);
  TwoTr->Project("E12dS","E12",cuts+South+dn);
  E12dS->SetLineColor(4);
  E12uS->Draw("esame");
  E12dS->Draw("esame");
  E12uS->Sumw2();
  E12dS->Sumw2();
  TH1F* E12S=new TH1F((*E12dS)+(*E12uS));
  TH1F* E12N=new TH1F((*E12dN)+(*E12uN));
  TH1F* E12=new TH1F((*E12N)+(*E12S));
  E12S->SetName("E12S");
  E12N->SetName("E12N");
  E12->SetName("E12");
  c1->SetTitle("UpN=blk  UpS=grn DnN=red DnS=blue");
  c2->cd();
  c2->SetTitle("U/D_N=blk  U/D_S=blue");
  TH1F* RS=new TH1F((*E12uS)/(*E12dS));
  RN->Draw("e");
  RS->SetLineColor(4);
  RS->Draw("esame");
  TH1F* crossR=new TH1F(at.GetCross(E12uS,E12dS,E12uN,E12dN,"CrossRat"));
  TCanvas* c3=new TCanvas("c3","c3",800,600);
  TString ctit="Cross Ratio: ";
  ctit=ctit+cuts;
  crossR->SetTitle(ctit);
  crossR->GetXaxis()->SetTitle("E12 (GeV)");
  crossR->GetYaxis()->SetTitle("raw cross An");
  crossR->Draw();

    c1->Write();
  c2->Write();
  c3->Write();
  crossR->Write();
  RN->Write();
  RS->Write();
  E12uS->Write();
  E12dS->Write();
  E12dN->Write();
  E12uN->Write();
  E12S->Write();
  E12N->Write();
  E12->Write();
  NSsp->Write();
  fout.cd("../");

  /* usage example
TFile fout("fout.root");
TH1F* h=(TH1F*) ((TDirectory*)fout.Get("DirEcut1set7nb20"))->Get("CrossRat");h->Draw()
  */

}
