{
  gROOT->Reset();
  gROOT->Macro("start.C");
  Int_t cutnumber=3;
  Int_t nbins=12;
  TString CutNum=gSystem->Getenv("Cut");
  Int_t nn;
  if(CutNum!="")
    {
      sscanf((const char*) CutNum,"%d",&nn);
      cutnumber=nn;
      printf("nn=%d \n",nn);
    };
  

  char dirname[200];
  Long_t pathmask=0x1FE;
  TString PathMask=gSystem->Getenv("PathMask");
  if(PathMask!="")
    {
      sscanf((const char*) PathMask,"%lx",&pathmask);
    };
  printf("%s -> %lX \n",(const char*) PathMask,pathmask );
  sprintf(dirname,"Dircut%dset%lx_nb%d",cutnumber,pathmask,nbins);
  printf("%s \n",dirname);
 
  gROOT->Macro("CommonSpin.C");

  TH1F* PtuN=new TH1F("PtuN","uN",nbins,0,25.);
  TH1F* PtdN=new TH1F("PtdN","dN",nbins,0,25.);
  TH1F* PtuS=new TH1F("PtuS","uS",nbins,0,25.);
  TH1F* PtdS=new TH1F("PtdS","dS",nbins,0,25.);
  TString cutlist[20];
  TString cuts0="abs(Eta-3.3)<.7&&N12==1 &&abs(E12-70)<20";
  TString cuts1="abs(Eta-3.3)<.7&&N12==1 &&abs(E12-110)<20";
  TString cuts2="abs(Eta-3.3)<.7&&N12==1 &&abs(E12-150)<20";
  TString cuts3="abs(Eta-3.3)<.7&&N12==2 &&abs(M12-.17)<.13 &&abs(E12-80)<20";
  TString cuts4="abs(Eta-3.3)<.7&&N12==2 &&abs(M12-.17)<.13 &&abs(E12-40)<20";
  TString cuts5="abs(Eta-3.3)<.7&&N12==1 &&abs(E12-60)<10";
  TString cuts6="abs(Eta-3.3)<.7&&N12>2 &&M12>.8";
  TString cuts7="abs(Eta-3.3)<.7&&N12==2 &&abs(M12-3.0)<.4&&abs(E12-70)<20";
  TString cuts8="Z<.7&&abs(Eta-3.5)<.3&&N12==2 &&abs(M12-.55)<.15&&abs(E12-140)<15";
  TString cuts9="abs(Eta-3.3)<.7&&N12==1 &&abs(E12-75)<10";
  cutlist[10]="abs(Eta-3.3)<.7&&N12==2 &&abs(E12-65)<15&&abs(M12-.13)<.10";
  cutlist[11]="abs(Eta-3.3)<.8&&N12==2 &&abs(E12-85)<20&&abs(M12-.13)<.10";
  cutlist[12]="abs(Eta-3.3)<.7&&N12==1 &&abs(E12-80)<20&&Ntracks==N12";
  cutlist[13]="Z<.7&&abs(Eta-3.5)<.6&&N12==2 &&abs(M12-.55)<.15&&abs(E12-100)<15&&Ntracks==N12"; 
  cutlist[14]="N12==2 &&abs(M12-.55)<.2&&abs(E12-150)<25"; 
  cutlist[15]="abs(M12-.55)<.2&&abs(E12-150)<20"; 
  cutlist[16]="abs(Eta-3.3)<.7&&N12==2 &&abs(E12-70)<20";
  cutlist[17]="abs(Eta-3.3)<.7&&N12==2 &&abs(E12-110)<20";
  cutlist[18]="abs(Eta-3.3)<.7&&N12==2 &&abs(E12-150)<20";
  cutlist[19]="abs(Eta-3.3)<.7&&(N12==1 || (N12==2 && abs(M12-.135)<.09)) &&abs(E12-70)<20";
  cutlist[0]=cuts0;
  cutlist[1]=cuts1;
  cutlist[2]=cuts2;
  cutlist[3]=cuts3;
  cutlist[4]=cuts4;
  cutlist[5]=cuts5;
  cutlist[6]=cuts6;
  cutlist[7]=cuts7;
  cutlist[8]=cuts8;
  cutlist[9]=cuts9;

  TString cuts=cutlist[cutnumber]+"&&"+TrigCut;

  TString North="&&cos(Phi)<-.5";
  TString South="&&cos(Phi)>.5";
  TString North="&&cos(Phi)<-.5";
  TString South="&&cos(Phi)>.5";
  TString Bdown="&&abs(spin-.5)<.6";
  TString Bup="&&abs(spin-2.5)<.6";
  TString Ydown="&&spin<4&&(spin%2==0)";
  TString Yup="&&spin<4&&(spin%2==1)";
  //note the reversal of spin signs from CDev files??
  TString dn=Bup;
  TString up=Bdown;
  if(useyellow)
    {
      dn=Yup;
      up=Ydown;
    }

  TwoTr->Project("PtuN","Pt",cuts+North+up);
  PtuN->SetLineColor(1);
  TwoTr->Project("PtdN","Pt",cuts+North+dn);
  PtdN->SetLineColor(2);
  PtuN->Draw("e");
  PtdN->Draw("esame");
  PtuN->Sumw2();  

  PtdN->Sumw2();
  TH1F* RN=new TH1F((*PtuN)/(*PtdN));
  TwoTr->Project("PtuS","Pt",cuts+South+up);
  PtuS->SetLineColor(3);
  TwoTr->Project("PtdS","Pt",cuts+South+dn);
  PtdS->SetLineColor(4);
  PtuS->Draw("esame");
  PtdS->Draw("esame");
  PtuS->Sumw2();
  PtdS->Sumw2();

  TH1F* PtN=new TH1F((*PtuN)+(*PtdN));
  TH1F* PtS=new TH1F((*PtuS)+(*PtdS));
  TH1F* Pt=new TH1F((*PtS)+(*PtN));
  PtN->SetName("PtN");
  PtS->SetName("PtS");
  Pt->SetName("Pt");

  c1->SetTitle("UpN=blk  UpS=grn DnN=red DnS=blue");
  c2->cd();
  c2->SetTitle("U/D_N=blk  U/D_S=blue");

  TH1F* RS=new TH1F((*PtuS)/(*PtdS));
  RN->Draw("e");
  RS->SetLineColor(4);
  RS->Draw("esame");
  TH1F* crossR=new TH1F(at.GetCross(PtuS,PtdS,PtuN,PtdN,"CrossRat"));
  TCanvas* c3=new TCanvas("c3","c3",800,600);
  TString ctit="Cross Ratio: ";
  ctit=ctit+cuts;
  crossR->SetTitle(ctit);
  crossR->GetXaxis()->SetTitle("Pt (GeV)");
  crossR->GetYaxis()->SetTitle("raw cross An");
  crossR->Draw();
  c1->Write();
  c2->Write();
  c3->Write();
  crossR->Write();
  RN->Write();
  RS->Write();
  PtuS->Write();
  PtdS->Write();
  PtdN->Write();
  PtuN->Write();  
  PtN->Write();
  PtS->Write();
  Pt->Write();
  fout.cd("../");
  /* usage example
TFile fout("fout.root");
TH1F* h=(TH1F*) ((TDirectory*)fout.Get("Dircut1set7nb20"))->Get("CrossRat");h->Draw()
  */

}
