{
  gROOT->Reset();
  gROOT->Macro("start.C");
  Int_t cutnumber=3;
  Int_t nbins=12;
  TString NBinMask=gSystem->Getenv("NBinMask");
  if(NBinMask != "")
    {
      sscanf((const char*) NBinMask,"%d",&nbins);
      printf("nbins=%d \n",nbins)
    }
  TString CutNum=gSystem->Getenv("Cut");
  Int_t nn;
  if(CutNum!="")
    {
      sscanf((const char*) CutNum,"%d",&nn);
      cutnumber=nn;
      printf("nn=%d \n",nn);
    };
  

  char dirname[200];
  Long_t pathmask=0x1FE;
  TString PathMask=gSystem->Getenv("PathMask");
  if(PathMask!="")
    {
      sscanf((const char*) PathMask,"%lx",&pathmask);
    };
  printf("%s -> %lX \n",(const char*) PathMask,pathmask );
  sprintf(dirname,"Dir5dcut%dset%lx_nb%d",cutnumber,pathmask,nbins);
  printf("%s \n",dirname);
 
  gROOT->Macro("CommonSpin.C");

  TH1F* PtuN=new TH1F("PtuN","uN",nbins,0,24.);
  TH1F* PtdN=new TH1F("PtdN","dN",nbins,0,24.);
  TH1F* PtuS=new TH1F("PtuS","uS",nbins,0,24.);
  TH1F* PtdS=new TH1F("PtdS","dS",nbins,0,24.);

  TString cutlist[50];

  TString cuta="N12==2 && abs(E12-50)<10 &&Z<.8";
  TString cutb="N12==2 &&  abs(E12-70)<10&&Z<.8";
  TString cutc="N12==2 &&  abs(E12-90)<10&&Z<.8";
  Int_t NMass=12;
  for (int k=0;k<NMass;k++)
    {
      char setp[200];
      sprintf(setp,"&&abs(M12-%f)<.19",(k*.4)+.20);
      cutlist[k]=cuta+setp;
      cutlist[k+NMass]=cutb+setp;
      cutlist[k+2*NMass]=cutc+setp;
    }  
  TString cuts=cutlist[cutnumber]+"&&"+TrigCut+ "&&abs(spin-1.5)<1.9 ";


  TString North="&&cos(Phi)<-.5";
  TString South="&&cos(Phi)>.5";
  TString Bdown="&&abs(spin-.5)<.6";
  TString Bup="&&abs(spin-2.5)<.6";
  TString Ydown="&&spin<4&&(spin%2==0)";
  TString Yup="&&spin<4&&(spin%2==1)";
  //note the reversal of spin signs from CDev files??
  TString dn=Bup;
  TString up=Bdown;
  TwoTr->Project("PtuN","abs(Pt*cos(Phi)+Ptaway*cos(Phiaway))",cuts+North+up);
  PtuN->SetLineColor(1);
  TwoTr->Project("PtdN","abs(Pt*cos(Phi)+Ptaway*cos(Phiaway))",cuts+North+dn);
  PtdN->SetLineColor(2);
  PtuN->Draw("e");
  PtdN->Draw("esame");
  PtuN->Sumw2();  

  PtdN->Sumw2();
  TH1F* RN=new TH1F((*PtuN)/(*PtdN));
  TwoTr->Project("PtuS","abs(Pt*cos(Phi)+Ptaway*cos(Phiaway))",cuts+South+up);
  PtuS->SetLineColor(3);
  TwoTr->Project("PtdS","abs(Pt*cos(Phi)+Ptaway*cos(Phiaway))",cuts+South+dn);
  PtdS->SetLineColor(4);
  PtuS->Draw("esame");
  PtdS->Draw("esame");
  PtuS->Sumw2();
  PtdS->Sumw2();
  TH1F* PtN=new TH1F((*PtuN)+(*PtdN));
  TH1F* PtS=new TH1F((*PtuS)+(*PtdS));
  TH1F* Pt=new TH1F((*PtS)+(*PtN));
  PtN->SetName("PtN");
  PtS->SetName("PtS");
  Pt->SetName("Pt");
  PtN->SetTitle(cuts);
  PtS->SetTitle(cuts);
  Pt->SetTitle(cuts);
  c1->SetTitle("UpN=blk  UpS=grn DnN=red DnS=blue");
  c2->cd();
  c2->SetTitle("U/D_N=blk  U/D_S=blue");
  TH1F* RS=new TH1F((*PtuS)/(*PtdS));
  RN->Draw("e");
  RS->SetLineColor(4);
  RS->Draw("esame");
  TH1F* crossR=new TH1F(at.GetCross(PtuS,PtdS,PtuN,PtdN,"CrossRat"));
  TCanvas* c3=new TCanvas("c3","c3",800,600);
  TString ctit="Cross Ratio: ";
  ctit=ctit+cuts;
  crossR->SetTitle(ctit);
  crossR->GetXaxis()->SetTitle("Pt_xall (GeV)");
  crossR->GetYaxis()->SetTitle("raw cross An");
  crossR->Draw();
  c1->Write();
  c2->Write();
  c3->Write();
  crossR->Write();
  RN->Write();
  RS->Write();
  PtuS->Write();
  PtdS->Write();
  PtdN->Write();
  PtuN->Write();
  PtN->Write();
  PtS->Write();
  Pt->Write();
  fout.cd("../");
  /* usage example
TFile fout("fout.root");
TH1F* h=(TH1F*) ((TDirectory*)fout.Get("Dircut1set7nb20"))->Get("CrossRat");h->Draw()
  */

}
