{
  gROOT->Macro("start.C");
  Int_t cutnumber=12;
  TString CutNum=gSystem->Getenv("Cut");
  Int_t nn;
  if(CutNum!="")
    {
      sscanf((const char*) CutNum,"%d",&nn);
      cutnumber=nn;
    };
  
  Int_t nbins=50;
  //  nbins=5;
  char dirname[200];
  Long_t pathmask=0x1FE;
  TString PathMask=gSystem->Getenv("PathMask");
  if(PathMask!="")
    {
      sscanf((const char*) PathMask,"%lx",&pathmask);
    };

  sprintf(dirname,"DirMcut%dset%lx_nb%d",cutnumber,pathmask,nbins);
  printf("%s \n",dirname);
  gROOT->Macro("CommonSpin.C");

  TH1F* M12=new TH1F("M12","M12",nbins,0,4.);
  TH1F* M12uN=new TH1F("M12uN","uN",nbins,0,4.);
  TH1F* M12dN=new TH1F("M12dN","dN",nbins,0,4.);
  TH1F* M12uS=new TH1F("M12uS","uS",nbins,0,4.);
  TH1F* M12dS=new TH1F("M12dS","dS",nbins,0,4);


  TString cutlist[40];
  TString cuta="N12==2 && abs(E12-80)<15";
  TString cutb="N12==2 && abs(E12-110)<15";
  TString cutc="N12==2 && abs(E12-150)<25";
  Int_t Neta=12;
  for (int k=0;k<Neta;k++)
    {
      char setp[200];
      sprintf(setp,"&&abs(Eta-%f)<.05",k*.1+2.85);
      cutlist[k]=cuta+setp;
      cutlist[k+Neta]=cutb+setp;
      cutlist[k+2*Neta]=cutc+setp;
    }  
  TString cuts=cutlist[cutnumber]+"&&"+TrigCut+ "&&abs(spin-1.5)<1.9 ";


  TString North="&&cos(Phi)<-.5";
  TString South="&&cos(Phi)>.5";
  TString Bdown="&&abs(spin-.5)<.6";
  TString Bup="&&abs(spin-2.5)<.6";
  TString Ydown="&&spin<4&&(spin%2==0)";
  TString Yup="&&spin<4&&(spin%2==1)";
  TString dn=Bup;
  TString up=Bdown;
  if(useyellow)
    {
      dn=Yup;
      up=Ydown;
    }
  TH2F* NSsp=new TH2F("NSsp","NSsp",nbins,0,4.,8,0,8);
  TwoTr->Project("NSsp","((cos(Phi)<0)*(spin&3))+((cos(Phi)>0)*((spin&3)+4)):M12",cuts);
  M12->GetXaxis()->SetTitle("M12 (GeV)");
  TwoTr->Project("M12","M12",cuts);
  TwoTr->Project("M12uN","M12",cuts+North+up);
  M12uN->SetLineColor(1);
  TwoTr->Project("M12dN","M12",cuts+North+dn);
  M12dN->SetLineColor(2);
  M12uN->Draw("e");
  M12dN->Draw("esame");
  M12uN->Sumw2();  

  M12dN->Sumw2();
  TH1F* RN=new TH1F((*M12uN)/(*M12dN));
  TwoTr->Project("M12uS","M12",cuts+South+up);
  M12uS->SetLineColor(3);
  TwoTr->Project("M12dS","M12",cuts+South+dn);
  M12dS->SetLineColor(4);
  M12uS->Draw("esame");
  M12dS->Draw("esame");
  M12uS->Sumw2();
  M12dS->Sumw2();
  c1->SetTitle("UpN=blk  UpS=grn DnN=red DnS=blue");
  c2->cd();
  c2->SetTitle("U/D_N=blk  U/D_S=blue");
  TH1F* RS=new TH1F((*M12uS)/(*M12dS));
  RN->Draw("e");
  RS->SetLineColor(4);
  RS->Draw("esame");
  TH1F* crossR=new TH1F(at.GetCross(M12uS,M12dS,M12uN,M12dN,"CrossRat"));
  TCanvas* c3=new TCanvas("c3","c3",800,600);
  TString ctit="Cross Ratio: ";
  ctit=ctit+cuts;
  crossR->SetTitle(ctit);
  crossR->GetXaxis()->SetTitle("M12 (GeV)");
  crossR->GetYaxis()->SetTitle("raw cross An");
  crossR->Draw();
  c1->Write();
  c2->Write();
  c3->Write();
  crossR->Write();
  RN->Write();
  RS->Write();
  M12->Write();
  M12uS->Write();
  M12dS->Write();
  M12dN->Write();
  M12uN->Write();
  NSsp->Write();
  fout.cd("../");
  /* usage example
TFile fout("fout.root");
TH1F* h=(TH1F*) ((TDirectory*)fout.Get("DirMcut1set7nb20"))->Get("CrossRat");h->Draw()
  */

}
