{
  gROOT->Macro("start.C");
  AnalTools at;
  TCanvas* c2=new TCanvas("c2","c2",800,600);
  TCanvas* c1=new TCanvas("c1","c1",800,600);
  TChain* TwoTr=new TChain("TwoTr");
  TString paths[10];
  Int_t pathmask=7;
  Int_t cutnumber=0;
  Int_t nbins=16;
  char dirname[200];
  sprintf(dirname,"DirPhicut%dset%dnb%d",cutnumber,pathmask,nbins);
  paths[0]="../OFiles/Output95_10.root";
  paths[1]="../OFiles/Output9596_13.root";
  paths[2]="../OFiles/Output96_7.root";
  paths[3]="../OFiles/Output95_10a.root";
  paths[4]="../OFiles/Output95_6td_b.root";
  for(int j=0;j<5;j++)
    {
      if((1<<j)&pathmask)
	{
	  TwoTr->Add(paths[j]);
	  std::cout<<paths[j]<<"\n";
	};
    };
  TFile fout("fout.root","update");
  if( fout.GetListOfKeys()->FindObject(dirname))
    {
      fout.cd(dirname);
    }
  else
    {
      fout.mkdir(dirname);
      fout.cd(dirname);
    };
  TH1F* dPhiuN=new TH1F("dPhiuN","uN",nbins,-3.1415,3.1415);
  TH1F* dPhidN=new TH1F("dPhidN","dN",nbins,-3.1415,3.1415);
  TH1F* dPhiuS=new TH1F("dPhiuS","uN",nbins,-3.1415,3.1415);
  TH1F* dPhidS=new TH1F("dPhidS","dN",nbins,-3.1415,3.1415);
  TString cuts0="abs(Eta-3.3)<.7&& N12==2&&Ntracks>2&&NE>180 && E12<150";

  TString cutlist[10];
  cutlist[0]=cuts0;

  TString cuts=cutlist[cutnumber];
  TString North="&&cos(Phi)<-.5";
  TString South="&&cos(Phi)>.5";
  TString Bdown="&&abs(spin-.5)<.6";
  TString Bup="&&abs(spin-2.5)<.6";
  TString Ydown="&&spin<4&&(spin%2==0)";
  TString Yup="&&spin<4&&(spin%2==1)";
  TString dn=Bdown;
  TString up=Bup;
  if(useyellow)
    {
      dn=Yup;
      up=Ydown;
    };

  TwoTr->Project("dPhiuN","atan2(sin(Phiaway-Phi),cos(Phiaway-Phi))",cuts+North+dn);
  dPhiuN->SetLineColor(1);
  TwoTr->Project("dPhidN","atan2(sin(Phiaway-Phi),cos(Phiaway-Phi))",cuts+North+up);
  dPhidN->SetLineColor(2);
  dPhiuN->Draw("e");
  dPhidN->Draw("esame");
  dPhiuN->Sumw2();  

  dPhidN->Sumw2();
  TH1F* RN=new TH1F((*dPhiuN)/(*dPhidN));
  TwoTr->Project("dPhiuS","atan2(sin(Phiaway-Phi),cos(Phiaway-Phi))",cuts+South+dn);
  dPhiuS->SetLineColor(3);
  TwoTr->Project("dPhidS","atan2(sin(Phiaway-Phi),cos(Phiaway-Phi))",cuts+South+up);
  dPhidS->SetLineColor(4);
  dPhiuS->Draw("esame");
  dPhidS->Draw("esame");
  dPhiuS->Sumw2();
  dPhidS->Sumw2();
  c1->SetTitle("UpN=blk  UpS=grn DnN=red DnS=blue");
  c2->cd();
  c2->SetTitle("U/D_N=blk  U/D_S=blue");
  TH1F* RS=new TH1F((*dPhiuS)/(*dPhidS));
  RN->Draw("e");
  RS->SetLineColor(4);
  RS->Draw("esame");
  TH1F* crossR=new TH1F(at.GetCross(dPhiuS,dPhidS,dPhiuN,dPhidN,"CrossRat"));
  TCanvas* c3=new TCanvas("c3","c3",800,600);
  TString ctit="Cross Ratio: ";
  ctit=ctit+cuts;
  crossR->SetTitle(ctit);
  crossR->GetXaxis()->SetTitle("dPhi (GeV)");
  crossR->GetYaxis()->SetTitle("raw cross An");
  crossR->Draw();
  c1->Write();
  c2->Write();
  c3->Write();
  crossR->Write();
  RN->Write();
  RS->Write();
  dPhiuS->Write();
  dPhidS->Write();
  dPhidN->Write();
  dPhiuN->Write();
  fout.cd("../");
  /* usage example
TFile fout("fout.root");
TH1F* h=(TH1F*) ((TDirectory*)fout.Get("DirMcut1set7nb20"))->Get("CrossRat");h->Draw()
  */

}
