{
  gROOT->Macro("start.C");
  Int_t cutnumber=7;
  Int_t nbins=32;
  char dirname[200];
  Long_t pathmask=0x1FC;
  TString PathMask=gSystem->Getenv("PathMask");
  TString CutNum=gSystem->Getenv("Cut");
  TString Yellow=gSystem->Getenv("Yellow");
  if(PathMask!="")
    {
      sscanf((const char*) PathMask,"%lx",&pathmask);
    };
  Int_t nn;
  if(CutNum!="")
    {
      sscanf((const char*) CutNum,"%d",&nn);
      cutnumber=nn;
    };

  sprintf(dirname,"Dirphixycut%dset%lx_nb%d%s",cutnumber,pathmask,nbins(const char* ) Yellow);
  printf("%s \n",dirname);

  gROOT->Macro("CommonSpin.C");
  
  Float_t lolim=-3.14159;
  Float_t hilim=3.14159;

  TString var="atan2(dthy,dthx)";
  TH1F* phixy=new TH1F("phixy","uN",nbins,lolim,hilim);
  TH1F* phixyu=new TH1F("phixyu","uN",nbins,lolim,hilim);
  TH1F* phixyd=new TH1F("phixyd","dN",nbins,lolim,hilim);
  TH1F* phixyN=new TH1F("phixyN","N",nbins,lolim,hilim);
  TH1F* phixyS=new TH1F("phixyS","S",nbins,lolim,hilim);
  TH1F* phixyuN=new TH1F("phixyuN","uN",nbins,lolim,hilim);
  TH1F* phixydN=new TH1F("phixydN","dN",nbins,lolim,hilim);
  TH1F* phixyuS=new TH1F("phixyuS","uS",nbins,lolim,hilim);
  TH1F* phixydS=new TH1F("phixydS","dS",nbins,lolim,hilim);
  
  
  TString cutlist[20];
  for(int jj=0;jj<20;jj++)cutlist[jj]="";
  cutlist[0]="abs(Eta-3.3)<.7&&N12>2&&Ntracks==N12 &&abs(EC12-90)<50&&abs(M12)>.25&&abs(abs(cos(Phi))-.5)<.4";
  cutlist[1]="abs(Eta-3.3)<.7&&N12>2&&Ntracks==N12 &&abs(EC12-90)<50&&abs(M12)<.2&&abs(abs(cos(Phi))-.5)<.4";
  cutlist[2]="abs(Eta-3.3)<.7&&N12==2&&Ntracks==N12 &&abs(EC12-90)<50&&abs(MC12)>.2&&abs(abs(cos(Phi))-.5)<.4";
  cutlist[3]="abs(Eta-3.3)<.7&&N12==2&&Ntracks==N12 &&abs(EC12-90)<50&&abs(MC12)<.2&&abs(abs(cos(Phi))-.5)<.4";
  cutlist[4]="abs(Eta-3.3)<.7&&N12==2&&Ntracks==N12 &&abs(EC12-90)<50&&abs(MC12)-.2<.2&&abs(abs(cos(Phi))-.5)<.4";
  cutlist[5]="abs(Eta-3.3)<.7&&N12==2&&Ntracks==N12 &&abs(EC12-90)<50&&abs(MC12)>.7&&abs(abs(cos(Phi))-.5)<.4";
  cutlist[6]="abs(Eta-3.3)<.7&&N12==2&&Ntracks==N12 &&abs(EC12-110)<50&&abs(MC12)>.7&&abs(abs(cos(Phi))-.5)<.4";
  cutlist[7]="abs(Eta-3.3)<.7&&N12==2&&Ntracks==N12 &&abs(EC12-110)<50&&abs(MC12-1.6)<.9&&abs(abs(cos(Phi))-.5)<.4&&Z>.7&&sqrt(dthx*dthx+dthy*dthy)>.002";
  cutlist[8]="abs(Eta-3.3)<.7&&N12==2&&Ntracks==N12 &&abs(EC12-110)<50&&abs(MC12-1.6)<.9&&abs(abs(cos(Phi))-.5)<.4&&Z>.7&&sqrt(dthx*dthx+dthy*dthy)>.0005";
  cutlist[9]="abs(Eta-3.3)<.7&&N12==2&&Ntracks>N12 &&abs(EC12-110)<50&&abs(MC12-1.6)<.9&&abs(abs(cos(Phi))-.5)<.4&&Z>.7&&sqrt(dthx*dthx+dthy*dthy)>.0005";
  cutlist[10]="abs(Eta-3.3)<.7&&N12==2&&Ntracks==N12 &&abs(EC12-110)<50&&abs(MC12-1.6)<.9&&abs(abs(cos(Phi))-.5)<.4&&Z>.7&&sqrt(dthx*dthx+dthy*dthy)>.0001";
  cutlist[11]="abs(Eta-3.3)<.7&&N12==2&&Ntracks==N12 &&abs(EC12-110)<50&&abs(MC12-.55)<.2&&abs(abs(cos(Phi))-.5)<.4&&Z<.7&&sqrt(dthx*dthx+dthy*dthy)>.0001";
  cutlist[12]="abs(Eta-3.3)<.7&&N12==2&&Ntracks==N12 &&abs(EC12-110)<50&&abs(MC12-1.6)<.9&&sqrt(dthx*dthx+dthy*dthy)>.004";

  //  TString cuts=cutlist[cutnumber];
 TString cuts=cutlist[cutnumber]+"&&"+TrigCut;

  TString North="&&cos(Phi)<-.5";
  TString South="&&cos(Phi)>.5";
  TString North0="&&cos(Phi)<0";
  TString South0="&&cos(Phi)>0";

  TString Bdown="&&abs(spin-.5)<.6";
  TString Bup="&&abs(spin-2.5)<.6";
  TString Ydown="&&spin<4&&(spin%2==0)";
  TString Yup="&&spin<4&&(spin%2==1)";
  TString dn=Bup;
  TString up=Bdown;

  if(useyellow)
    {
      dn=Yup;
      up=Ydown;
    };

  TwoTr->Project("phixy",var,cuts);
  TwoTr->Project("phixyu",var,cuts+up);
  TwoTr->Project("phixyd",var,cuts+dn);
  TF1 fc("fc","[2]+cos(x+[1])*[0]",-3.14159,3.14159);
  fc->SetParameter(0,.03);
  fc->SetParameter(1,.0);
  fc->SetParameter(2,.0);
  TwoTr->Project("phixyuN",var,cuts+North+up);
  phixyuN->SetLineColor(1);
  TwoTr->Project("phixydN",var,cuts+North+dn);
  phixydN->SetLineColor(2);
  phixyuN->Draw("e");
  phixydN->Draw("esame");
  phixyuN->Sumw2();  

  phixydN->Sumw2();
  TH1F* RN=new TH1F((*phixyuN)/(*phixydN));
  TwoTr->Project("phixyuS",var,cuts+South+up);
  phixyuS->SetLineColor(3);
  TwoTr->Project("phixydS",var,cuts+South+dn);

  TwoTr->Project("phixyN",var,cuts+North0);
  phixyN->SetLineColor(2);
  phixyS->SetLineColor(3);

  TwoTr->Project("phixyS",var,cuts+South0);
  phixydS->SetLineColor(4);
  phixyuS->Draw("esame");
  phixydS->Draw("esame");
  phixyuS->Sumw2();
  phixydS->Sumw2();
  c1->SetTitle("UpN=blk  UpS=grn DnN=red DnS=blue");
  c2->cd();
  c2->SetTitle("U/D_N=blk  U/D_S=blue");
  TH1F* RS=new TH1F((*phixyuS)/(*phixydS));
  RN->Draw("e");
  RS->SetLineColor(4);
  RS->Draw("esame");
  TH1F* crossR=new TH1F(at.GetCross(phixyuS,phixydS,phixyuN,phixydN,"CrossRat"));
  TCanvas* c3=new TCanvas("c3","c3",800,600);
  TString ctit="Cross Ratio: ";
  ctit=ctit+cuts;
  crossR->SetTitle(ctit);
  crossR->GetXaxis()->SetTitle("phixy (GeV)");
  crossR->GetYaxis()->SetTitle("raw cross An");
  crossR->Draw();
  TH1F* asm=new TH1F(at.GetAsm(phixyu,phixyd,"Asm"));
  TString ctit="Asymmetry: ";
  ctit=ctit+cuts;
  asm->SetTitle(ctit);
  asm->GetXaxis()->SetTitle("phixy");
  asm->GetYaxis()->SetTitle("raw  An");
  asm->Draw();
  asm->Fit("fc","","",-3.14159,3.14159);
  c1->Write();
  c2->Write();
  c3->Write();
  crossR->Write();
  asm->Write();
  RN->Write();
  RS->Write();
  phixy->Write();
  phixyu->Write();
  phixyd->Write();
  phixyN->Write();
  phixyS->Write();
  phixyuS->Write();
  phixydS->Write();
  phixydN->Write();
  phixyuN->Write();
  fout.cd("../");
  /* usage example
TFile fout("fout.root");
TH1F* h=(TH1F*) ((TDirectory*)fout.Get("Dirphixycut10set120nb16"))->Get("Asm");h->Draw()
  */

}
