{
  gROOT->Macro("start.C");
  Int_t cutnumber=1;
  TString CutNum=gSystem->Getenv("Cut");
  Int_t nn;
  if(CutNum!="")
    {
      sscanf((const char*) CutNum,"%d",&nn);
      cutnumber=nn;
      printf("nn=%d \n",nn);
    };
  
  Int_t nbins=10;
  char dirname[200];
  Long_t pathmask=0x1FE;
  TString PathMask=gSystem->Getenv("PathMask");
  if(PathMask!="")
    {
      sscanf((const char*) PathMask,"%lx",&pathmask);
    };
  TString Fill[10];
  TString SFill[10];
  Fill[0]="";
  Fill[1]="&&Rnum>=12095005 &&Rnum<=12095023";
  Fill[2]="&&Rnum>=12095037 &&Rnum<=12095064";
  SFill[0]="";
  SFill[1]="_Fill15397";
  SFill[2]="_Fill15399";
  Int_t fcutnumber=0;
  sprintf(dirname,"DirCcut%dset%lx_nb%d_f%d",cutnumber,pathmask,nbins,fcutnumber);
  
  gROOT->Macro("CommonSpin.C");
  printf("%s \n",(const char*) DirName);

  TH1F* cPhiu=new TH1F("cPhiu","u",nbins,-1,1);
  TH1F* cPhid=new TH1F("cPhid","d",nbins,-1,1);

  TString cutlist[60];
  int cutcnt=0;
  Float_t seteta=3.35;
  Float_t deta=.05;
  Float_t elow=50.;
  Float_t ehi=100.;
  TString smallcut="(abs(730*2/5.8*exp(-Eta)*cos(Phi))<8&&abs(730*2/5.8*exp(-Eta)*sin(Phi))<8)";
  TString largecut=TString("!")+smallcut;
  TString phicut="cos(Phi)<1.1";


  for(elow=40;elow<90;elow+=20)
    {
      float ehi=elow+20;
      char echar[200];
      for(seteta=2.65;seteta<4.1;seteta+=2*deta)
	{
	  //	  phicut=smallcut; 
	  printf("elow=%f seteta=%f \n",elow,seteta);

	  sprintf(echar,
		  "&&N12==2 && Z<.7 && abs(Eta-%4.2f)<%4.2f && abs(E12-%5.1f)<%5.1f && abs(M12-.21)<.19",		  
		  seteta,deta,(elow+ehi)/2,(ehi-elow)/2);
	  printf("%s \n",echar);
	  cutlist[cutcnt++]=phicut+echar;
	  cout<<"cutlist["<<cutcnt-1<<"]="<<cutlist[cutcnt-1]<<"\n";
/*
	  phicut=largecut; 
	  printf("elow=%f seteta=%f \n",elow,seteta);

	  sprintf(echar,
		  "&&N12==2 && Z<.8 && abs(Eta-%4.2f)<%4.2f && abs(E12-%5.1f)<%5.1f && abs(M12-.135)<.1",		  
		  seteta+deta,deta,(elow+ehi)/2,(ehi-elow)/2);
	  printf("%s \n",echar);
	  cutlist[cutcnt++]=phicut+echar;
	  cout<<cutlist[cutcnt-1]<<"\n";
*/
	}
    };

  //  TString cuts=cutlist[cutnumber]+Fill[fcutnumber];

  cutlist[45]="N12==2 && Z<.7 && abs(M12-.21)<.19&&abs(Eta-3.35)<0.75&&abs(E12-50)<10";
  cutlist[46]="N12==2 && Z<.7 && abs(M12-.21)<.19&&abs(Eta-3.35)<0.75&&abs(E12-70)<10";

  cutlist[47]="N12==2 && Z<.7 && abs(M12-.21)<.19&&abs(Eta-3.35)<0.75&&abs(E12-90)<10";

  TString cuts=cutlist[cutnumber]+"&&"+TrigCut+ "&&abs(spin-1.5)<1.9 ";
  TString North="&&cos(Phi)<-.5";
  TString South="&&cos(Phi)>.5";
  TString Bdown="&&abs(spin-.5)<.6";
  TString Bup="&&abs(spin-2.5)<.6";
  TString Ydown="&&spin<4&&(spin%2==0)";
  TString Yup="&&spin<4&&(spin%2==1)";
  TString dn=Bup;
  TString up=Bdown;
  if(useyellow)
    {
      dn=Ydown;
      up=Yup;
    };

  TwoTr->Project("cPhiu","cos(Phi)",cuts+up);
  cPhiu->SetLineColor(1);
  TwoTr->Project("cPhid","cos(Phi)",cuts+dn);
  cPhid->SetLineColor(2);
  cPhiu->Draw("e");
  cPhid->Draw("esame");
  cPhiu->Sumw2();  

  cPhid->Sumw2();
  TH1F* RN=new TH1F((*cPhiu)/(*cPhid));
  c1->SetTitle("Up=blk Dn=red ");
  c2->cd();
  c2->SetTitle("U/D_N=blk");
  RN->Draw("e");
  //  TH1F* crossR=new TH1F(at.GetCross(cPhiuS,cPhidS,cPhiuN,cPhidN,"CrossRat"));
  TH1F* asm=new TH1F(at.GetAsm(cPhiu,cPhid,"Asm"));
  TCanvas* c3=new TCanvas("c3","c3",800,600);
  TString ctit="Asymmetry: ";
  ctit=ctit+cuts+SFill[fcutnumber];
  asm->SetTitle(ctit);
  asm->GetXaxis()->SetTitle("cos(Phi) (GeV)");
  asm->GetYaxis()->SetTitle("raw  An");
  gStyle->SetOptFit();
  asm->Fit("pol1","","",-1,1);
  asm->Draw();
  c1->Write();
  c2->Write();
  c3->Write();
  asm->Write();
  RN->Write();
  cPhiu->Write();
  cPhid->Write();
  fout.cd("../");
  /* usage example
TFile fout("fout.root");
TH1F* h=(TH1F*) ((TDirectory*)fout.Get("DirCcut0set56nb32"))->Get("Asm");h->Draw()
  */

}
